=== modified file '.bzrignore'
--- .bzrignore	2009-04-01 14:40:05 +0000
+++ .bzrignore	2009-02-10 01:57:06 +0000
@@ -6,4 +6,3 @@
 build
 *.log
 _trial_temp
-loggerhead-memprofile

=== modified file 'NEWS'
--- NEWS	2009-08-20 13:30:37 +0000
+++ NEWS	2009-03-01 20:21:01 +0000
@@ -1,166 +1,23 @@
 What's changed in loggerhead?
 =============================
 
-1.17 [20Aug2009]
+dev [future]
 ---------------
-
-    - Add bug links in revision informations (Alexandre Garnier, #314052)
-
-    - Make sure that binary files aren't annotated. (Martin Albisetti,
-      #258848)
-
-    - Loggerhead now serves bzr branches over HTTP and exposes the URL
-      to branch them. Addresses bug #240577. (Jonathan Lange)
-
-    - Leading blank lines in commit messages no longer result in an
-      empty summary. (Colin Watson)
-
-    - Added optional syntax highlighting to annotate view using
-      python-pygments.  Partially addresses bug #306631. (Peter Bui)
-
-    - Convert newlines in commit messages to HTML line breaks for
-      annotate and changelog views.  Addresses bug #273688. (Peter
-      Bui)
-
-    - serve-branches now errors if run behind a proxy without
-      paste.deploy installed. (Michael Hudson)
-
-    - Loggerhead should now handle file and directory names that need
-      URL escaping without crashing.
-
-    - The start-loggerhead script properly sets the wsgi.url_scheme
-      from the server.webpath option. (neror, #260547)
-
-    - The revision page defaults to unified style again, and can
-      convert to a side-by-side view using JavaScript. (Michael Hudson)
-
-    - Clean up and improve performance of the annotate view. (Michael
-      Hudson)
-
-    - Finish converting JavaScript from MooTools to YUI 3. (Michael
-      Hudson)
-
-    - Improve compatibility with IE 6. (Michael Hudson)
-
-    - Leading blank lines in commit messages no longer result in an
-      empty summary. (Colin Watson)
-
-    - Clip long lines in side-by-side diff view. (Michael Hudson,
-      #334837)
-
-    - The user-confusing "next" and "previous" links now read "older"
-      and "newer" respectively. (Michael Hudson, #297930)
-
-    - The annotate view now contains line number anchors. (Michael
-      Hudson)
-
-    - Fix inventory pages using "//" in links. (Michael Hudson, #329668)
-
-    - Fix problems viewing files and directories containing spaces and
-      other funny characters. (Peter Bui)
-
-    - Changelog messages are now displayed with newlines preserved.
-      (Peter Bui, #273688)
-
-    - Offer a link to see the full file diffs for a file path. (Michael
-      Hudson, #333797)
-
-    - Fix annotate error caused by Pygments stripping trailing
-      whitespace. (Michael Hudson, #338762)
-
-    - Loggerhead can be installed as a Bazaar plugin and run by
-      'bzr serve --http'. (Martin Pool)
-
-    - Load parts of the changelog and revision pages via XMLHttpRequest
-      to improve performance. This adds a dependency on simplejson or
-      json. Partially addresses bug #253950. (Michael Hudson)
-
-    - Various improvements to the animation JavaScript. (Michael Hudson)
-
-    - Fix HTML content of source files being displayed unescaped when
-      Pygments was unavailable. (Michael Hudson, #344970)
-
-    - Fix serve-branches's path argument. (Michael Hudson, #353230)
-
-    - serve-branches now has an option, --use-cdn, to load YUI from
-      Yahoo!'s CDN. (Matt Nordhoff)
-
-    - Fix certain race conditions for loading bzr-search. (Robert
-      Collins, #334250)
-
-    - Fix errors when using serve-branches --log-folder or --user-dirs.
-      (It was calling config.get_option() incorrectly.) (Matt Nordhoff,
-      bug #361238)
-
-    - Move some caching from RAM to the disk, and other caching and
-      memory usage improvements. (Michael Hudson)
-
-    - Add a --cache-dir option to serve-branches to choose where to
-      place the SQL cache, and only create one temporary SQL dir per
-      process. (Matt Nordhoff, #358322)
-
-    - Replace homebrew memory profiling code with Dozer. (Paul Hummer)
-
-    - Use the branch's public_branch as the default suggested URL to
-      branch from (Matt Nordhoff, #369767)
-
-    - Fix a file descriptor leak (Matt Nordhoff, #370845)
-
-    - Use transport API internally, so it is possible to specify a remote 
-      URL to serve-branches. (Jelmer Vernooij, #371787)
-
-    - Fix internal server errors when using start-loggerhead. (Matt
-      Nordhoff, #375948)
-
-    - Fix annotating non-UTF-8 files when Pygments is disabled. (Matt
-      Nordhoff, #376957)
-
-    - Fix 'bzr serve --http' errors. (Matt Nordhoff, #377551)
-
-    - Added the option to hide branches by setting http_serve = False
-      in locations.conf (Martin Albisetti)
-
-    - Fix serving branches over HTTP. (Matt Nordhoff, Jelmer Vernooij,
-      #380026)
-
-    - Install loggerhead as a bzr plugin by default (Jelmer Vernooij)
-
-    - Fix logging 404 Not Found responses (Matt Nordhoff, #381029)
-
-    - Bumped minimunm bzrlib version to 1.13 (Martin Albisetti)
-
-    - Make sure the Atom feeds (nearly) validate. (Matt Nordhoff, #247162)
-
-    - Support serving branches over HTTP using the smart server protocol.
-      (Jelmer Vernooij, #306853)
-
-    - Serving branch data was broken when --allow-writes was *not*
-      passed. (Michael Hudson, #388730)
-
-    - http_serve config values are interpreted more forgivingly.
-      (Michael Hudson)
-
-    - When specifying a remote url to serve-branches, do not share
-      connections between threads. (Michael Hudson, #390972)
-
-    - http_serve values from locations.conf are now applied to
-      non-branch .bzr data (e.g shared repositories). (Michael Hudson)
-
-    - tags are now displayed. (Cris Boylan, Alexandre Garnier, Michael
-      Hudson, #246739)
-
-    - Display Loggerhead's version number at the bottom of the page, and
-      add a <meta> generator tag also including the version numbers of
-      its dependencies. (Matt Nordhoff, #370155)
-
+    - Loggerhead now serves bzr branches over HTTP and exposes the URL to
+      branch them. (Jonathan Lange)
+
+    - Leading blank lines in commit messages no longer result in an empty
+      summary. (Colin Watson)
+
+    - Added syntax highlighting to annotate view using python-pygments.
+      Partially addresses bug #306631. (Peter Bui)
 
 1.10 [22Dec2008]
 ---------------
-
     - Add startup deamon script for Linux (Marius Kruger)
 
-    - Switch navigation from file_ids to paths. Fixes bugs #260363,
-      #269365 and #128926. (Martin Albisetti)
+    - Switch navigation from file_ids to paths. Fixes bugs #260363, #269365
+      and #128926. (Martin Albisetti)
 
     - Fix bug #258710 ("the /files page explodes in an empty branch").
       Also minor improvements to the /files and /changes pages.

=== renamed file 'README' => 'README.txt'
--- README	2009-10-17 09:31:45 +0000
+++ README.txt	2009-02-24 21:13:30 +0000
@@ -1,7 +1,7 @@
 LOGGERHEAD
 ==========
 
-[ Version 1.17 for Bazaar 1.17 ]
+[ Version 1.6 for Bazaar 1.6 ]
 
 Loggerhead is a web viewer for Bazaar branches.  It can be used to
 navigate a branch history, annotate files, perform searches... all the
@@ -11,19 +11,15 @@
 GETTING STARTED
 ---------------
 
-Loggerhead depends on:
-
+Loggerhead depends on 
 1) SimpleTAL for templating.
-   On Ubuntu, `sudo apt-get install python-simpletal`
+   on Ubuntu package `sudo apt-get install python-simpletal`
    or download from http://www.owlfish.com/software/simpleTAL/download.html
-2) simplejson for producing JSON data.
-   On Ubuntu, `sudo apt-get install python-simplejson`
-   or use `easy_install simplejson`.
-3) Paste for the server. (You need version 1.2 or newer of Paste.)
-   On Ubuntu, `sudo apt-get install python-paste`
+2) Paste for the server. (You need version 1.2 or newer of Paste.) 
+   on Ubuntu package `sudo apt-get install python-paste`
    or use `easy_install Paste`
-4) Paste Deploy  (optional, needed when proxying through Apache)
-   On Ubuntu, `sudo apt-get install python-pastedeploy`
+3) Paste Deploy  (optional, needed when proxying through Apache)
+   on Ubuntu package `sudo apt-get install python-pastedeploy`
    or use `easy_install PasteDeploy`
 
 Then simply run the 'serve-branches' with the branch you want to
@@ -40,7 +36,7 @@
 Loggerhead will notice and refresh, and Bazaar uses its own branch
 locking to prevent corruption.
 
-To run loggerhead as a linux daemon:
+To run loggerhead as a linux daemon: 
 1) Copy loggerheadd to /etc/init.d
 2) Edit the file to configure where your loggerhead is installed, and which
    serve-branches options you would like.
@@ -51,26 +47,34 @@
    b) on Sysvinit based systems like Centos or SuSE run:
       chkconfig --add loggerheadd
 
-
-LOGGERHEAD AS A BAZAAR PLUGIN
------------------------------
-
-This branch contains experimental support for using Loggerhead as a Bazaar
-plugin.  To use it, place the top-level Loggerhead directory (the one
-containing this file) at ``~/.bazaar/plugins/loggerhead``.
-
-
 USING A CONFIG FILE
 -------------------
 
-To hide branches from being displayed, add to ``~/.bazaar/locations.conf``,
-under the branch's section:
-
-    [/path/to/branch]
-    http_serve = False
-
-
-More configuration options to come soon.
+Previous versions of Loggerhead read their configuration from a config
+file.  This mode of operation is still supported by the
+'start-loggerhead' script.  A 'loggerhead.conf.example' file is
+included in the source which has comments explaining the various
+options.
+
+Loggerhead can then be started by running::
+
+    $ ./start-loggerhead
+
+This will run loggerhead in the background, listening on port 8080 by
+default.
+
+To stop Loggerhead, run::
+
+    $ ./stop-loggerhead
+
+In the configuration file you can configure projects, and branches per
+project.  The idea is that you could be publishing several (possibly
+unrelated) projects through the same loggerhead instance, and several
+branches for the same project.  See the "loggerhead.conf.example" file
+included with the source.
+
+A debug and access log are stored in the logs/ folder, relative to
+the location of the start-loggerhead script.
 
 
 SERVING LOGGERHEAD FROM BEHIND APACHE
@@ -90,14 +94,12 @@
 run behind a proxy at the root of a site, but if you're running it at
 some path into the site, you'll need to specify is using '--prefix=/some_path'.
 
-
-SEARCH
-------
-
-Search is currently supported by using the bzr-search plugin (available
-at: ``https://launchpad.net/bzr-search``
-You need to have the plugin installed and each branch indexed to allow
-searching on branches.
+FILES CHANGED CACHE
+-------------------
+
+To speed up the display of the changelog view for large trees,
+loggerhead can be configured to cache the files changes between
+revisions.  Set the 'cachepath' value in the config file.
 
 
 SUPPORT
@@ -113,12 +115,3 @@
 Bugs are tracked on Launchpad; start at:
 
     https://bugs.launchpad.net/loggerhead
-
-
-HACKING
--------
-
-To run loggerhead tests, you will need the package python-nose,
-and run in the loggerhead directory:
-
-    nosetests

=== removed file '__init__.py'
--- __init__.py	2009-10-17 06:35:33 +0000
+++ __init__.py	1970-01-01 00:00:00 +0000
@@ -1,122 +0,0 @@
-# Copyright 2009 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-# This file allows loggerhead to be treated as a plugin for bzr.
-#
-# XXX: Because loggerhead already contains a loggerhead directory, much of the
-# code is going to appear loaded at bzrlib.plugins.loggerhead.loggerhead.
-# This seems like the easiest thing, because bzrlib wants the top-level plugin
-# directory to be the module, but when it's used as a library people expect
-# the source directory to contain a directory called loggerhead.  -- mbp
-# 20090123
-
-"""Loggerhead web viewer for Bazaar branches.
-
-This provides a new option "--http" to the "bzr serve" command, that 
-starts a web server to browse the contents of a branch.
-"""
-
-version_info = (1, 17, 0)
-
-if __name__ == 'bzrlib.plugins.loggerhead':
-    import bzrlib
-    from bzrlib.api import require_any_api
-
-    require_any_api(bzrlib, [
-        (1, 13, 0), (1, 15, 0), (1, 16, 0), (1, 17, 0), (1, 18, 0),
-        (2, 0, 0), (2, 1, 0)])
-
-    # NB: Normally plugins should lazily load almost everything, but this
-    # seems reasonable to have in-line here: bzrlib.commands and options are
-    # normally loaded, and the rest of loggerhead won't be loaded until serve
-    # --http is run.
-
-    # transport_server_registry was added in bzr 1.16. When we drop support for
-    # older releases, we can remove the code to override cmd_serve.
-
-    try:
-        from bzrlib.transport import transport_server_registry
-    except ImportError:
-        transport_server_registry = None
-
-    DEFAULT_HOST = '0.0.0.0'
-    DEFAULT_PORT = 8080
-    HELP = ('Loggerhead, a web-based code viewer and server. (default port: %d)' %
-            (DEFAULT_PORT,))
-
-    def serve_http(transport, host=None, port=None, inet=None):
-        from paste.httpexceptions import HTTPExceptionHandler
-        from paste.httpserver import serve
-
-        # loggerhead internal code will try to 'import loggerhead', so
-        # let's put it on the path if we can't find it in the existing path
-        try:
-            import loggerhead
-        except ImportError:
-            import os.path, sys
-            sys.path.append(os.path.dirname(__file__))
-
-        from loggerhead.apps.transport import BranchesFromTransportRoot
-        from loggerhead.config import LoggerheadConfig
-
-        if host is None:
-            host = DEFAULT_HOST
-        if port is None:
-            port = DEFAULT_PORT
-        argv = ['--host', host, '--port', str(port), '--', transport.base]
-        if not transport.is_readonly():
-            argv.insert(0, '--allow-writes')
-        config = LoggerheadConfig(argv)
-        app = BranchesFromTransportRoot(transport.base, config)
-        app = HTTPExceptionHandler(app)
-        serve(app, host=host, port=port)
-
-    if transport_server_registry is not None:
-        transport_server_registry.register('http', serve_http, help=HELP)
-    else:
-        import bzrlib.builtins
-        from bzrlib.commands import get_cmd_object, register_command
-        from bzrlib.option import Option
-
-        _original_command = get_cmd_object('serve')
-
-        class cmd_serve(bzrlib.builtins.cmd_serve):
-            __doc__ = _original_command.__doc__
-
-            takes_options = _original_command.takes_options + [
-                Option('http', help=HELP)]
-
-            def run(self, *args, **kw):
-                if 'http' in kw:
-                    from bzrlib.transport import get_transport
-                    allow_writes = kw.get('allow_writes', False)
-                    path = kw.get('directory', '.')
-                    port = kw.get('port', DEFAULT_PORT)
-                    # port might be an int already...
-                    if isinstance(port, basestring) and ':' in port:
-                        host, port = port.split(':')
-                    else:
-                        host = DEFAULT_HOST
-                    if allow_writes:
-                        transport = get_transport(path)
-                    else:
-                        transport = get_transport('readonly+' + path)
-                    serve_http(transport, host, port)
-                else:
-                    super(cmd_serve, self).run(*args, **kw)
-
-        register_command(cmd_serve)

=== modified file 'loggerhead/__init__.py'
--- loggerhead/__init__.py	2009-08-20 13:30:37 +0000
+++ loggerhead/__init__.py	2009-02-10 21:11:43 +0000
@@ -1,6 +1,3 @@
-#
-# Copyright (C) 2008, 2009 Canonical Ltd.
-#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
@@ -22,8 +19,8 @@
 
 import pkg_resources
 
-__version__ = '1.17'
-required_bzrlib = (1, 17)
+__version__ = '1.10'
+required_bzrlib = (1, 6)
 
 pkg_resources.get_distribution('Paste>=1.6')
 try:

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2009-10-17 06:35:33 +0000
+++ loggerhead/apps/branch.py	2009-02-18 10:36:48 +0000
@@ -1,19 +1,3 @@
-# Copyright (C) 2008, 2009 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
 """The WSGI application for serving a Bazaar branch."""
 
 import logging
@@ -27,16 +11,14 @@
 from paste import httpexceptions
 
 from loggerhead.apps import static_app
+from loggerhead.controllers.changelog_ui import ChangeLogUI
+from loggerhead.controllers.inventory_ui import InventoryUI
 from loggerhead.controllers.annotate_ui import AnnotateUI
+from loggerhead.controllers.revision_ui import RevisionUI
 from loggerhead.controllers.atom_ui import AtomUI
-from loggerhead.controllers.changelog_ui import ChangeLogUI
-from loggerhead.controllers.diff_ui import DiffUI
 from loggerhead.controllers.download_ui import DownloadUI
-from loggerhead.controllers.filediff_ui import FileDiffUI
-from loggerhead.controllers.inventory_ui import InventoryUI
-from loggerhead.controllers.revision_ui import RevisionUI
-from loggerhead.controllers.revlog_ui import RevLogUI
 from loggerhead.controllers.search_ui import SearchUI
+from loggerhead.controllers.diff_ui import DiffUI
 from loggerhead.history import History
 from loggerhead import util
 
@@ -47,38 +29,33 @@
 
     def __init__(self, branch, friendly_name=None, config={},
                  graph_cache=None, branch_link=None, is_root=False,
-                 served_url=_DEFAULT, use_cdn=False):
+                 served_url=_DEFAULT):
         self.branch = branch
         self._config = config
         self.friendly_name = friendly_name
         self.branch_link = branch_link  # Currently only used in Launchpad
-        self.log = logging.getLogger('loggerhead.%s' % (friendly_name,))
+        self.log = logging.getLogger('loggerhead.%s' % friendly_name)
         if graph_cache is None:
-            graph_cache = bzrlib.lru_cache.LRUCache(10)
+            graph_cache = bzrlib.lru_cache.LRUCache()
         self.graph_cache = graph_cache
         self.is_root = is_root
         self.served_url = served_url
-        self.use_cdn = use_cdn
 
     def get_history(self):
-        file_cache = None
-        revinfo_disk_cache = None
+        _history = History(self.branch, self.graph_cache)
         cache_path = self._config.get('cachepath', None)
         if cache_path is not None:
             # Only import the cache if we're going to use it.
             # This makes sqlite optional
             try:
-                from loggerhead.changecache import (
-                    FileChangeCache, RevInfoDiskCache)
+                from loggerhead.changecache import FileChangeCache
             except ImportError:
                 self.log.debug("Couldn't load python-sqlite,"
                                " continuing without using a cache")
             else:
-                file_cache = FileChangeCache(cache_path)
-                revinfo_disk_cache = RevInfoDiskCache(cache_path)
-        return History(
-            self.branch, self.graph_cache, file_cache=file_cache,
-            revinfo_disk_cache=revinfo_disk_cache, cache_key=self.friendly_name)
+                _history.use_file_cache(
+                    FileChangeCache(_history, cache_path))
+        return _history
 
     def url(self, *args, **kw):
         if isinstance(args[0], list):
@@ -86,7 +63,7 @@
         qs = []
         for k, v in kw.iteritems():
             if v is not None:
-                qs.append('%s=%s' % (k, urllib.quote(v)))
+                qs.append('%s=%s'%(k, urllib.quote(v)))
         qs = '&'.join(qs)
         return request.construct_url(
             self._environ, script_name=self._url_base,
@@ -100,24 +77,15 @@
     def static_url(self, path):
         return self._static_url_base + path
 
-    def yui_url(self, path):
-        if self.use_cdn:
-            base = 'http://yui.yahooapis.com/3.0.0pr2/build/'
-        else:
-            base = self.static_url('/static/javascript/yui/build/')
-        return base + path
-
     controllers_dict = {
-        '+filediff': FileDiffUI,
-        '+revlog': RevLogUI,
         'annotate': AnnotateUI,
-        'atom': AtomUI,
         'changes': ChangeLogUI,
-        'diff': DiffUI,
-        'download': DownloadUI,
         'files': InventoryUI,
         'revision': RevisionUI,
+        'download': DownloadUI,
+        'atom': AtomUI,
         'search': SearchUI,
+        'diff': DiffUI,
         }
 
     def last_updated(self):
@@ -125,30 +93,17 @@
         change = h.get_changes([h.last_revid])[0]
         return change.date
 
-    def public_branch_url(self):
+    def branch_url(self):
         return self.branch.get_config().get_user_option('public_branch')
 
     def app(self, environ, start_response):
-        # Check again if the branch is blocked from being served, this is
-        # mostly for tests. It's already checked in apps/transport.py
-        if self.branch.get_config().get_user_option('http_serve') == 'False':
-            raise httpexceptions.HTTPNotFound()
         self._url_base = environ['SCRIPT_NAME']
         self._static_url_base = environ.get('loggerhead.static.url')
         if self._static_url_base is None:
             self._static_url_base = self._url_base
         self._environ = environ
         if self.served_url is _DEFAULT:
-            public_branch = self.public_branch_url()
-            if public_branch is not None:
-                self.served_url = public_branch
-            else:
-                # Loggerhead only supports serving .bzr/ on local branches, so
-                # we shouldn't suggest something that won't work.
-                if self.branch.base.startswith('file://'):
-                    self.served_url = self.url([])
-                else:
-                    self.served_url = None
+            self.served_url = self.url([])
         path = request.path_info_pop(environ)
         if not path:
             raise httpexceptions.HTTPMovedPermanently(

=== modified file 'loggerhead/apps/config.py'
--- loggerhead/apps/config.py	2009-05-13 13:14:04 +0000
+++ loggerhead/apps/config.py	2008-12-15 21:23:24 +0000
@@ -108,17 +108,20 @@
                 friendly_name = history.get_config().get_nickname()
                 if friendly_name is None:
                     friendly_name = view_name
-            branch_url = self._get_branch_url(view, view_config, view_name)
-            description = self._get_description(view, view_config, history)
             self.view_data_by_name[view_name] = {
                 'branch_path': folder,
-                'config': view_config,
-                'description': description,
+                'args': (view_name, view_config, self.graph_cache),
+                'description': self._get_description(view,
+                                                     view_config,
+                                                     history),
+                '_src_folder': folder,
+                '_view_config': view_config,
                 'friendly_name': friendly_name,
-                'graph_cache': self.graph_cache,
                 'name': view_name,
-                'served_url': branch_url,
                 }
+            branch_url = self._get_branch_url(view, view_config, view_name)
+            if branch_url is not None:
+                self.view_data_by_name[view_name]['branch_url'] = branch_url
             self.view_names.append(view_name)
         finally:
             b.unlock()
@@ -129,13 +132,12 @@
             return None
         view_data = view_data.copy()
         branch_path = view_data.pop('branch_path')
-        description = view_data.pop('description')
-        name = view_data.pop('name')
+        args = view_data.pop('args')
         b = bzrlib.branch.Branch.open(branch_path)
         b.lock_read()
-        view = BranchWSGIApp(b, **view_data)
-        view.description = description
-        view.name = name
+        view = BranchWSGIApp(b, *args)
+        for k in view_data:
+            setattr(view, k, view_data[k])
         return view
 
     def call(self, environ, start_response):

=== modified file 'loggerhead/apps/error.py'
--- loggerhead/apps/error.py	2009-10-17 08:47:38 +0000
+++ loggerhead/apps/error.py	2008-10-24 02:26:05 +0000
@@ -53,6 +53,6 @@
 
 
 def errapp(environ, start_response):
-    """Default (and trivial) error handling WSGI application."""
+    '''Default (and trivial) error handling WSGI application.'''
     c = ErrorUI(environ['branch'], environ['exc_info'])
     return c(environ, start_response)

=== renamed file 'loggerhead/apps/transport.py' => 'loggerhead/apps/filesystem.py'
--- loggerhead/apps/transport.py	2009-10-21 12:12:42 +0000
+++ loggerhead/apps/filesystem.py	2009-02-19 18:04:11 +0000
@@ -1,27 +1,9 @@
-# Copyright (C) 2008, 2009 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-"""Serve branches at urls that mimic a transport's file system layout."""
-
-import threading
-
-from bzrlib import branch, errors, lru_cache, urlutils
-from bzrlib.config import LocationConfig
-from bzrlib.transport import get_transport
-from bzrlib.transport.http import wsgi
+"""Serve branches at urls that mimic the file system layout."""
+
+import os
+import tempfile
+
+from bzrlib import branch, errors, lru_cache
 
 from paste.request import path_info_pop
 from paste import httpexceptions
@@ -31,36 +13,26 @@
 from loggerhead.apps import favicon_app, static_app
 from loggerhead.controllers.directory_ui import DirectoryUI
 
-_bools = {
-    'yes': True, 'no': False,
-    'on': True, 'off': False,
-    '1': True, '0': False,
-    'true': True, 'false': False,
-    }
-
-class BranchesFromTransportServer(object):
-
-    def __init__(self, transport, root, name=None):
-        self.transport = transport
+sql_dir = tempfile.mkdtemp(prefix='loggerhead-cache-')
+
+
+class BranchesFromFileSystemServer(object):
+
+    def __init__(self, path, root, name=None):
+        self.path = path
         self.root = root
         self.name = name
-        self._config = root._config
 
     def app_for_branch(self, branch):
         if not self.name:
-            name = branch._get_nick(local=True)
+            name = branch.get_config().get_nickname()
             is_root = True
         else:
             name = self.name
             is_root = False
         branch_app = BranchWSGIApp(
-            branch,
-            name,
-            {'cachepath': self._config.SQL_DIR},
-            self.root.graph_cache,
-            is_root=is_root,
-            use_cdn=self._config.get_option('use_cdn'),
-            )
+            branch, name, {'cachepath': sql_dir}, self.root.graph_cache,
+            is_root=is_root)
         return branch_app.app
 
     def app_for_non_branch(self, environ):
@@ -73,78 +45,33 @@
                 name = self.name
             else:
                 name = '/'
-            return DirectoryUI(
-                environ['loggerhead.static.url'], self.transport, name)
+            return DirectoryUI(environ['loggerhead.static.url'],
+                               self.path,
+                               name)
         else:
-            new_transport = self.transport.clone(segment)
+            new_path = os.path.join(self.path, segment)
             if self.name:
-                new_name = urlutils.join(self.name, segment)
+                new_name = os.path.join(self.name, segment)
             else:
                 new_name = '/' + segment
-            return BranchesFromTransportServer(new_transport, self.root, new_name)
-
-    def app_for_bazaar_data(self, relpath):
-        if relpath == '/.bzr/smart':
-            wsgi_app = wsgi.SmartWSGIApp(self.transport)
-            return wsgi.RelpathSetter(wsgi_app, '', 'PATH_INFO')
-        else:
-            # TODO: Use something here that uses the transport API
-            # rather than relying on the local filesystem API.
-            base = self.transport.base
-            readonly_prefix = 'readonly+'
-            if base.startswith(readonly_prefix):
-                base = base[len(readonly_prefix):]
-            try:
-                path = urlutils.local_path_from_url(base)
-            except errors.InvalidURL:
-                raise httpexceptions.HTTPNotFound()
-            else:
-                return urlparser.make_static(None, path)
-
-    def check_serveable(self, config):
-        value = config.get_user_option('http_serve')
-        if value is None:
-            return
-        elif not _bools.get(value.lower(), True):
+            return BranchesFromFileSystemServer(new_path, self.root, new_name)
+
+    def __call__(self, environ, start_response):
+        if not os.path.isdir(self.path):
             raise httpexceptions.HTTPNotFound()
-
-    def __call__(self, environ, start_response):
-        path = environ['PATH_INFO']
         try:
-            b = branch.Branch.open_from_transport(self.transport)
+            b = branch.Branch.open(self.path)
         except errors.NotBranchError:
-            if path.startswith('/.bzr'):
-                self.check_serveable(LocationConfig(self.transport.base))
-                return self.app_for_bazaar_data(path)(environ, start_response)
-            if not self.transport.listable() or not self.transport.has('.'):
-                raise httpexceptions.HTTPNotFound()
             return self.app_for_non_branch(environ)(environ, start_response)
         else:
-            self.check_serveable(b.get_config())
-            if path.startswith('/.bzr'):
-                return self.app_for_bazaar_data(path)(environ, start_response)
-            else:
-                return self.app_for_branch(b)(environ, start_response)
-
-
-_transport_store = threading.local()
-
-def get_transport_for_thread(base):
-    thread_transports = getattr(_transport_store, 'transports', None)
-    if thread_transports is None:
-        thread_transports = _transport_store.transports = {}
-    if base in thread_transports:
-        return thread_transports[base]
-    transport = get_transport(base)
-    return transport
-
-
-class BranchesFromTransportRoot(object):
-
-    def __init__(self, base, config):
-        self.graph_cache = lru_cache.LRUCache(10)
-        self.base = base
-        self._config = config
+            return self.app_for_branch(b)(environ, start_response)
+
+
+class BranchesFromFileSystemRoot(object):
+
+    def __init__(self, folder):
+        self.graph_cache = lru_cache.LRUCache()
+        self.folder = folder
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
@@ -154,23 +81,24 @@
             return static_app(environ, start_response)
         elif environ['PATH_INFO'] == '/favicon.ico':
             return favicon_app(environ, start_response)
+        elif '/.bzr/' in environ['PATH_INFO']:
+            app = urlparser.make_static(None, self.folder)
+            return app(environ, start_response)
         else:
-            transport = get_transport_for_thread(self.base)
-            return BranchesFromTransportServer(
-                transport, self)(environ, start_response)
-
-
-class UserBranchesFromTransportRoot(object):
-
-    def __init__(self, base, config):
-        self.graph_cache = lru_cache.LRUCache(10)
-        self.base = base
-        self._config = config
-        self.trunk_dir = config.get_option('trunk_dir')
+            return BranchesFromFileSystemServer(
+                self.folder, self)(environ, start_response)
+
+
+class UserBranchesFromFileSystemRoot(object):
+
+    def __init__(self, folder, trunk_dir):
+        self.graph_cache = lru_cache.LRUCache()
+        self.folder = folder
+        self.trunk_dir = trunk_dir
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
-        path_info = environ['PATH_INFO']
+        path_info= environ['PATH_INFO']
         if path_info.startswith('/static/'):
             segment = path_info_pop(environ)
             assert segment == 'static'
@@ -178,14 +106,13 @@
         elif path_info == '/favicon.ico':
             return favicon_app(environ, start_response)
         else:
-            transport = get_transport_for_thread(self.base)
             # segments starting with ~ are user branches
             if path_info.startswith('/~'):
                 segment = path_info_pop(environ)
-                return BranchesFromTransportServer(
-                    transport.clone(segment[1:]), self, segment)(
-                    environ, start_response)
+                new_path = os.path.join(self.folder, segment[1:])
+                return BranchesFromFileSystemServer(
+                    new_path, self, segment)(environ, start_response)
             else:
-                return BranchesFromTransportServer(
-                    transport.clone(self.trunk_dir), self)(
-                    environ, start_response)
+                new_path = os.path.join(self.folder, self.trunk_dir)
+                return BranchesFromFileSystemServer(
+                    new_path, self)(environ, start_response)

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2009-05-02 14:01:05 +0000
+++ loggerhead/changecache.py	2008-10-24 02:26:05 +0000
@@ -17,63 +17,46 @@
 #
 
 """
-a cache for chewed-up 'file change' data structures, which are basically just
-a different way of storing a revision delta.  the cache improves lookup times
-10x over bazaar's xml revision structure, though, so currently still worth
-doing.
+a cache for chewed-up "change" data structures, which are basically just a
+different way of storing a revision.  the cache improves lookup times 10x
+over bazaar's xml revision structure, though, so currently still worth doing.
 
 once a revision is committed in bazaar, it never changes, so once we have
 cached a change, it's good forever.
 """
 
 import cPickle
-import marshal
 import os
-import tempfile
-import zlib
+
+from loggerhead import util
+from loggerhead.lockfile import LockFile
+
+with_lock = util.with_lock('_lock', 'ChangeCache')
 
 try:
     from sqlite3 import dbapi2
 except ImportError:
     from pysqlite2 import dbapi2
 
-# We take an optimistic approach to concurrency here: we might do work twice
-# in the case of races, but not crash or corrupt data.
-
-def safe_init_db(filename, init_sql):
-    # To avoid races around creating the database, we create the db in
-    # a temporary file and rename it into the ultimate location.
-    fd, temp_path = tempfile.mkstemp(dir=os.path.dirname(filename))
-    os.close(fd)
-    con = dbapi2.connect(temp_path)
-    cur = con.cursor()
-    cur.execute(init_sql)
-    con.commit()
-    con.close()
-    os.rename(temp_path, filename)
 
 class FakeShelf(object):
 
     def __init__(self, filename):
         create_table = not os.path.exists(filename)
-        if create_table:
-            safe_init_db(
-                filename, "create table RevisionData "
-                "(revid binary primary key, data binary)")
         self.connection = dbapi2.connect(filename)
         self.cursor = self.connection.cursor()
+        if create_table:
+            self._create_table()
 
-    def _create_table(self, filename):
-        con = dbapi2.connect(filename)
-        cur = con.cursor()
-        cur.execute(
+    def _create_table(self):
+        self.cursor.execute(
             "create table RevisionData "
             "(revid binary primary key, data binary)")
-        con.commit()
-        con.close()
+        self.connection.commit()
 
     def _serialize(self, obj):
-        return dbapi2.Binary(cPickle.dumps(obj, protocol=2))
+        r = dbapi2.Binary(cPickle.dumps(obj, protocol=2))
+        return r
 
     def _unserialize(self, data):
         return cPickle.loads(str(data))
@@ -87,72 +70,49 @@
         else:
             return self._unserialize(filechange[0])
 
-    def add(self, revid, object):
-        try:
+    def add(self, revid_obj_pairs):
+        for (r, d) in revid_obj_pairs:
             self.cursor.execute(
                 "insert into revisiondata (revid, data) values (?, ?)",
-                (revid, self._serialize(object)))
-            self.connection.commit()
-        except dbapi2.IntegrityError:
-            # If another thread or process attempted to set the same key, we
-            # assume it set it to the same value and carry on with our day.
-            pass
+                (r, self._serialize(d)))
+        self.connection.commit()
 
 
 class FileChangeCache(object):
 
-    def __init__(self, cache_path):
+    def __init__(self, history, cache_path):
+        self.history = history
 
         if not os.path.exists(cache_path):
             os.mkdir(cache_path)
 
         self._changes_filename = os.path.join(cache_path, 'filechanges.sql')
 
-    def get_file_changes(self, entry):
+        # use a lockfile since the cache folder could be shared across
+        # different processes.
+        self._lock = LockFile(os.path.join(cache_path, 'filechange-lock'))
+
+    @with_lock
+    def get_file_changes(self, entries):
+        out = []
+        missing_entries = []
+        missing_entry_indices = []
         cache = FakeShelf(self._changes_filename)
-        changes = cache.get(entry.revid)
-        if changes is None:
-            changes = self.history.get_file_changes_uncached(entry)
-            cache.add(entry.revid, changes)
-        return changes
-
-
-class RevInfoDiskCache(object):
-    """Like `RevInfoMemoryCache` but backed in a sqlite DB."""
-
-    def __init__(self, cache_path):
-        if not os.path.exists(cache_path):
-            os.mkdir(cache_path)
-        filename = os.path.join(cache_path, 'revinfo.sql')
-        create_table = not os.path.exists(filename)
-        if create_table:
-            safe_init_db(
-                filename, "create table Data "
-                "(key binary primary key, revid binary, data binary)")
-        self.connection = dbapi2.connect(filename)
-        self.cursor = self.connection.cursor()
-
-    def get(self, key, revid):
-        self.cursor.execute(
-            "select revid, data from data where key = ?", (dbapi2.Binary(key),))
-        row = self.cursor.fetchone()
-        if row is None:
-            return None
-        elif str(row[0]) != revid:
-            return None
-        else:
-            return marshal.loads(zlib.decompress(row[1]))
-
-    def set(self, key, revid, data):
-        try:
-            self.cursor.execute(
-                'delete from data where key = ?', (dbapi2.Binary(key), ))
-            blob = zlib.compress(marshal.dumps(data))
-            self.cursor.execute(
-                "insert into data (key, revid, data) values (?, ?, ?)",
-                map(dbapi2.Binary, [key, revid, blob]))
-            self.connection.commit()
-        except dbapi2.IntegrityError:
-            # If another thread or process attempted to set the same key, we
-            # don't care too much -- it's only a cache after all!
-            pass
+        for entry in entries:
+            changes = cache.get(entry.revid)
+            if changes is not None:
+                out.append(changes)
+            else:
+                missing_entries.append(entry)
+                missing_entry_indices.append(len(out))
+                out.append(None)
+        if missing_entries:
+            missing_changes = self.history.get_file_changes_uncached(
+                                  missing_entries)
+            revid_changes_pairs = []
+            for i, entry, changes in zip(
+                missing_entry_indices, missing_entries, missing_changes):
+                revid_changes_pairs.append((entry.revid, changes))
+                out[i] = changes
+            cache.add(revid_changes_pairs)
+        return out

=== removed file 'loggerhead/config.py'
--- loggerhead/config.py	2009-10-17 08:47:38 +0000
+++ loggerhead/config.py	1970-01-01 00:00:00 +0000
@@ -1,110 +0,0 @@
-#
-# Copyright (C) 2008, 2009 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-"""Configuration tools for Loggerhead."""
-
-from optparse import OptionParser
-import sys
-import tempfile
-
-from bzrlib import config
-
-_temporary_sql_dir = None
-
-def _get_temporary_sql_dir():
-    global _temporary_sql_dir
-    if _temporary_sql_dir is None:
-        _temporary_sql_dir = tempfile.mkdtemp(prefix='loggerhead-cache-')
-    return _temporary_sql_dir
-
-def command_line_parser():
-    parser = OptionParser("%prog [options] <path>")
-    parser.set_defaults(
-        user_dirs=False,
-        show_version=False,
-        log_folder=None,
-        use_cdn=False,
-        sql_dir=None,
-        allow_writes=False,
-        )
-    parser.add_option("--user-dirs", action="store_true",
-                      help="Serve user directories as ~user.")
-    parser.add_option("--trunk-dir", metavar="DIR",
-                      help="The directory that contains the trunk branches.")
-    parser.add_option("--port", dest="user_port",
-                      help=("Port Loggerhead should listen on "
-                            "(defaults to 8080)."))
-    parser.add_option("--host", dest="user_host",
-                      help="Host Loggerhead should listen on.")
-    parser.add_option("--memory-profile", action="store_true",
-                      help="Profile the memory usage using Dozer.")
-    parser.add_option("--prefix", dest="user_prefix",
-                      help="Specify host prefix.")
-    parser.add_option("--profile", action="store_true",
-                      help="Generate callgrind profile data to "
-                        "%d-stats.callgrind on each request.")
-    parser.add_option("--reload", action="store_true",
-                      help="Restarts the application when changing python"
-                           " files. Only used for development purposes.")
-    parser.add_option("--log-folder",
-                      help="The directory to place log files in.")
-    parser.add_option("--version", action="store_true", dest="show_version",
-                      help="Print the software version and exit")
-    parser.add_option("--use-cdn", action="store_true", dest="use_cdn",
-                      help="Serve YUI from Yahoo!'s CDN")
-    parser.add_option("--cache-dir", dest="sql_dir",
-                      help="The directory to place the SQL cache in")
-    parser.add_option("--allow-writes", action="store_true",
-                      help="Allow writing to the Bazaar server.")
-    return parser
-
-
-class LoggerheadConfig(object):
-    """A configuration object."""
-
-    def __init__(self, argv=None):
-        if argv is None:
-            argv = sys.argv[1:]
-        self._parser = command_line_parser()
-        self._options, self._args = self._parser.parse_args(argv)
-
-        sql_dir = self.get_option('sql_dir')
-        if sql_dir is None:
-            sql_dir = _get_temporary_sql_dir()
-        self.SQL_DIR = sql_dir
-
-    def get_option(self, option):
-        """Get the value for the config option, either 
-        from ~/.bazaar/bazaar.conf or from the command line.
-        All loggerhead-specific settings start with 'http_'
-        """
-        global_config = config.GlobalConfig().get_user_option('http_'+option)
-        cmd_config = getattr(self._options, option)
-        if global_config is not None and (
-            cmd_config is None or cmd_config is False):
-            return global_config
-        else:
-            return cmd_config
-
-    def get_arg(self, index):
-        """Get an arg from the arg list."""
-        return self._args[index]
-
-    def print_help(self):
-        """Wrapper around OptionParser.print_help."""
-        return self._parser.print_help()
-
-    @property
-    def arg_count(self):
-        """Return the number of args from the option parser."""
-        return len(self._args)

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2009-10-17 08:59:33 +0000
+++ loggerhead/controllers/__init__.py	2009-03-02 02:45:13 +0000
@@ -17,6 +17,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+import re
 import time
 
 from paste.request import path_info_pop, parse_querystring
@@ -33,10 +34,14 @@
         self.buf = []
         self.buflen = 0
         self.writefunc = writefunc
+        self.bytes_saved = 0
         self.buf_limit = buf_limit
 
     def flush(self):
-        self.writefunc(''.join(self.buf))
+        chunk = ''.join(self.buf)
+        chunk = re.sub(r'\s*\n\s*', '\n', chunk)
+        self.bytes_saved += self.buflen - len(chunk)
+        self.writefunc(chunk)
         self.buf = []
         self.buflen = 0
 
@@ -70,7 +75,7 @@
         kwargs = dict(parse_querystring(environ))
         util.set_context(kwargs)
         args = []
-        while True:
+        while 1:
             arg = path_info_pop(environ)
             if arg is None:
                 break
@@ -103,8 +108,12 @@
         template.expand_into(w, **vals)
         w.flush()
         self.log.info(
-            'Rendering %s: %r secs, %s bytes' % (
-                self.__class__.__name__, time.time() - z, w.bytes))
+            'Rendering %s: %r secs, %s bytes, %s (%2.1f%%) bytes saved' % (
+                self.__class__.__name__,
+                time.time() - z,
+                w.bytes,
+                w.bytes_saved,
+                100.0*w.bytes_saved/w.bytes))
         return []
 
     def get_revid(self):

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2009-10-17 06:35:33 +0000
+++ loggerhead/controllers/annotate_ui.py	2009-03-02 00:10:26 +0000
@@ -17,21 +17,16 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import cgi
 import os
 import time
 
 import bzrlib.errors
 import bzrlib.textfile
-import bzrlib.osutils
 
 from paste.httpexceptions import HTTPBadRequest, HTTPServerError
 
 from loggerhead.controllers import TemplatedBranchView
-try:
-    from loggerhead.highlight import highlight
-except ImportError:
-    highlight = None
+from loggerhead.highlight import highlight
 from loggerhead import util
 
 
@@ -49,29 +44,16 @@
 
         file_name = os.path.basename(self._history.get_path(revid, file_id))
 
-        file_text = tree.get_file_text(file_id)
-        encoding = 'utf-8'
-        try:
-            file_text = file_text.decode(encoding)
-        except UnicodeDecodeError:
-            encoding = 'iso-8859-15'
-            file_text = file_text.decode(encoding)
-
-        file_lines = bzrlib.osutils.split_lines(file_text)
-
-        try:
+        try:
+            file_lines = tree.get_file_lines(file_id)
             bzrlib.textfile.check_text_lines(file_lines)
         except bzrlib.errors.BinaryFile:
-            # bail out; this isn't displayable text
-            yield util.Container(parity=0, lineno=1, status='same',
-                                 text='(This is a binary file.)',
-                                 change=util.Container())
+                # bail out; this isn't displayable text
+                yield util.Container(parity=0, lineno=1, status='same',
+                                     text='(This is a binary file.)',
+                                     change=util.Container())
         else:
-            if highlight is not None:
-                hl_lines = highlight(file_name, file_text, encoding)
-                hl_lines.extend([u''] * (len(file_lines) - len(hl_lines)))
-            else:
-                hl_lines = map(cgi.escape, file_lines)
+            hl_lines = highlight(file_name, ''.join(file_lines))
 
             change_cache = {}
 
@@ -95,7 +77,7 @@
                     change=change, text=hl_lines[lineno - 1])
                 lineno += 1
 
-        self.log.debug('annotate: %r secs' % (time.time() - z,))
+        self.log.debug('annotate: %r secs' % (time.time() - z))
 
     def get_values(self, path, kwargs, headers):
         history = self._history

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2009-07-07 23:52:24 +0000
+++ loggerhead/controllers/atom_ui.py	2008-12-05 18:52:44 +0000
@@ -26,6 +26,7 @@
 
     def get_values(self, path, kwargs, headers):
         history = self._history
+        revid = self.get_revid()
         pagesize = int(20)#self._branch.config.get('pagesize', '20'))
 
         revid_list = history.get_file_view(history.last_revid, None)
@@ -34,6 +35,6 @@
         headers['Content-Type'] = 'application/atom+xml'
         return {
             'changes': entries,
-            'updated': entries[0].utc_date.isoformat(),
+            'updated': entries[0].date.isoformat() + 'Z',
             'history': self._history,
         }

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2009-06-25 03:35:43 +0000
+++ loggerhead/controllers/changelog_ui.py	2008-12-05 18:52:44 +0000
@@ -1,5 +1,4 @@
 #
-# Copyright (C) 2008, 2009 Canonical Ltd.
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
 # Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
 #
@@ -18,13 +17,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import urllib
-
-try:
-    import simplejson
-except ImportError:
-    import json as simplejson
-
 from paste.httpexceptions import HTTPServerError
 
 from loggerhead import util
@@ -66,10 +58,7 @@
                 scan_list = revid_list[i:]
             change_list = scan_list[:pagesize]
             changes = list(history.get_changes(change_list))
-            data = {}
-            for i, c in enumerate(changes):
-                c.index = i
-                data[str(i)] = urllib.quote(urllib.quote(c.revid, safe=''))
+            history.add_changes(changes)
         except:
             self.log.exception('Exception fetching changes')
             raise HTTPServerError('Could not fetch changes')
@@ -82,6 +71,9 @@
             navigation.query = query
         util.fill_in_navigation(navigation)
 
+        # add parent & merge-point branch-nick info, in case it's useful
+        history.get_branch_nicks(changes)
+
         # Directory Breadcrumbs
         directory_breadcrumbs = (
             util.directory_breadcrumbs(
@@ -89,17 +81,9 @@
                 self._branch.is_root,
                 'changes'))
 
-        show_tag_col = False
-        for change in changes:
-            if change.tags is not None:
-                show_tag_col = True
-                break
-
         return {
             'branch': self._branch,
             'changes': changes,
-            'show_tag_col': show_tag_col,
-            'data': simplejson.dumps(data),
             'util': util,
             'history': history,
             'revid': revid,

=== modified file 'loggerhead/controllers/diff_ui.py'
--- loggerhead/controllers/diff_ui.py	2009-10-17 08:59:33 +0000
+++ loggerhead/controllers/diff_ui.py	2008-12-05 18:52:44 +0000
@@ -38,7 +38,7 @@
         z = time.time()
 
         args = []
-        while True:
+        while 1:
             arg = path_info_pop(environ)
             if arg is None:
                 break
@@ -73,7 +73,7 @@
         headers = [
             ('Content-Type', 'application/octet-stream'),
             ('Content-Length', len(content)),
-            ('Content-Disposition', 'attachment; filename=%s' % (filename,)),
+            ('Content-Disposition', 'attachment; filename=%s' % filename),
             ]
         start_response('200 OK', headers)
         return [content]

=== modified file 'loggerhead/controllers/directory_ui.py'
--- loggerhead/controllers/directory_ui.py	2009-10-17 06:35:33 +0000
+++ loggerhead/controllers/directory_ui.py	2008-12-05 18:52:44 +0000
@@ -18,9 +18,9 @@
 
 import datetime
 import logging
-import stat
+import os
 
-from bzrlib import branch, errors
+from bzrlib import branch
 
 from loggerhead import util
 from loggerhead.controllers import TemplatedBranchView
@@ -48,7 +48,7 @@
 
     template_path = 'loggerhead.templates.directory'
 
-    def __init__(self, static_url_base, transport, name):
+    def __init__(self, static_url_base, path, name):
 
         class _branch(object):
             context_url = 1
@@ -57,29 +57,24 @@
             def static_url(path):
                 return self._static_url_base + path
         self._branch = _branch
-        self._history_callable = lambda: None
+        self._history_callable = lambda:None
+        self._path = path
         self._name = name
         self._static_url_base = static_url_base
-        self.transport = transport
         self.log = logging.getLogger('')
 
     def get_values(self, path, kwargs, response):
-        listing = [d for d in self.transport.list_dir('.')
-                   if not d.startswith('.')]
+        listing = [d for d in os.listdir(self._path)
+                   if not d.startswith('.')
+                   and os.path.isdir(os.path.join(self._path, d))]
         listing.sort(key=lambda x: x.lower())
         dirs = []
         parity = 0
         for d in listing:
+            p = os.path.join(self._path, d)
             try:
-                b = branch.Branch.open_from_transport(self.transport.clone(d))
-                if b.get_config().get_user_option('http_serve') == 'False':
-                    continue
+                b = branch.Branch.open(p)
             except:
-                try:
-                    if not stat.S_ISDIR(self.transport.stat(d).st_mode):
-                        continue
-                except errors.NoSuchFile:
-                    continue
                 b = None
             dirs.append(DirEntry(d, parity, b))
             parity = 1 - parity

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2009-10-17 09:21:55 +0000
+++ loggerhead/controllers/download_ui.py	2009-02-06 05:53:36 +0000
@@ -19,6 +19,7 @@
 
 import logging
 import mimetypes
+import time
 import urllib
 
 from paste import httpexceptions
@@ -33,11 +34,12 @@
 
     def __call__(self, environ, start_response):
         # /download/<rev_id>/<file_id>/[filename]
+        z = time.time()
 
         h = self._history
 
         args = []
-        while True:
+        while 1:
             arg = path_info_pop(environ)
             if arg is None:
                 break
@@ -63,7 +65,7 @@
             ('Content-Type', mime_type),
             ('Content-Length', len(content)),
             ('Content-Disposition',
-             "attachment; filename*=utf-8''%s" % (encoded_filename,)),
+             'attachment; filename*=utf-8\'\'%s' % encoded_filename),
             ]
         start_response('200 OK', headers)
         return [content]

=== modified file 'loggerhead/controllers/error_ui.py'
--- loggerhead/controllers/error_ui.py	2009-10-17 08:47:38 +0000
+++ loggerhead/controllers/error_ui.py	2008-12-05 18:52:44 +0000
@@ -28,19 +28,22 @@
     template_path = 'loggerhead.templates.error'
 
     def __init__(self, branch, exc_info):
-        super(ErrorUI, self).__init__(branch, lambda: None)
+        super(ErrorUI, self).__init__(branch, lambda:None)
         self.exc_info = exc_info
 
     def get_values(self, path, kwargs, response):
         exc_type, exc_object, exc_tb = self.exc_info
         description = StringIO()
         traceback.print_exception(exc_type, exc_object, None, file=description)
-        directory_breadcrumbs = util.directory_breadcrumbs(
-            self._branch.friendly_name, self._branch.is_root, 'changes')
+        directory_breadcrumbs = (
+            util.directory_breadcrumbs(
+                self._branch.friendly_name,
+                self._branch.is_root,
+                'changes'))
         return {
             'branch': self._branch,
             'error_title': ('An unexpected error occurred while'
-                            'processing the request:'),
+                            'proccesing the request:'),
             'error_description': description.getvalue(),
             'directory_breadcrumbs': directory_breadcrumbs,
         }

=== removed file 'loggerhead/controllers/filediff_ui.py'
--- loggerhead/controllers/filediff_ui.py	2009-07-07 23:52:24 +0000
+++ loggerhead/controllers/filediff_ui.py	1970-01-01 00:00:00 +0000
@@ -1,92 +0,0 @@
-from StringIO import StringIO
-import urllib
-
-from bzrlib import diff
-from bzrlib import errors
-from bzrlib import osutils
-
-from loggerhead import util
-from loggerhead.controllers import TemplatedBranchView
-
-def _process_diff(difftext):
-    chunks = []
-    chunk = None
-    for line in difftext.splitlines():
-        if len(line) == 0:
-            continue
-        if line.startswith('+++ ') or line.startswith('--- '):
-            continue
-        if line.startswith('@@ '):
-            # new chunk
-            if chunk is not None:
-                chunks.append(chunk)
-            chunk = util.Container()
-            chunk.diff = []
-            split_lines = line.split(' ')[1:3]
-            lines = [int(x.split(',')[0][1:]) for x in split_lines]
-            old_lineno = lines[0]
-            new_lineno = lines[1]
-        elif line.startswith(' '):
-            chunk.diff.append(util.Container(old_lineno=old_lineno,
-                                             new_lineno=new_lineno,
-                                             type='context',
-                                             line=line[1:]))
-            old_lineno += 1
-            new_lineno += 1
-        elif line.startswith('+'):
-            chunk.diff.append(util.Container(old_lineno=None,
-                                             new_lineno=new_lineno,
-                                             type='insert', line=line[1:]))
-            new_lineno += 1
-        elif line.startswith('-'):
-            chunk.diff.append(util.Container(old_lineno=old_lineno,
-                                             new_lineno=None,
-                                             type='delete', line=line[1:]))
-            old_lineno += 1
-        else:
-            chunk.diff.append(util.Container(old_lineno=None,
-                                             new_lineno=None,
-                                             type='unknown',
-                                             line=repr(line)))
-    if chunk is not None:
-        chunks.append(chunk)
-    return chunks
-
-
-def diff_chunks_for_file(repository, file_id, compare_revid, revid):
-    lines = {}
-    args = []
-    for r in (compare_revid, revid):
-        if r == 'null:':
-            lines[r] = []
-        else:
-            args.append((file_id, r, r))
-    for r, bytes_iter in repository.iter_files_bytes(args):
-        lines[r] = osutils.split_lines(''.join(bytes_iter))
-    buffer = StringIO()
-    try:
-        diff.internal_diff('', lines[compare_revid], '', lines[revid], buffer)
-    except errors.BinaryFile:
-        difftext = ''
-    else:
-        difftext = buffer.getvalue()
-
-    return _process_diff(difftext)
-
-
-class FileDiffUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.filediff'
-
-    def get_values(self, path, kwargs, headers):
-        revid = urllib.unquote(self.args[0])
-        compare_revid = urllib.unquote(self.args[1])
-        file_id = urllib.unquote(self.args[2])
-
-        chunks = diff_chunks_for_file(
-            self._history._branch.repository, file_id, compare_revid, revid)
-
-        return {
-            'util': util,
-            'chunks': chunks,
-        }

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2009-03-19 00:44:05 +0000
+++ loggerhead/controllers/inventory_ui.py	2009-03-01 17:46:31 +0000
@@ -74,7 +74,7 @@
             if path == '':
                 absolutepath = pathname
             else:
-                absolutepath = path + '/' + pathname
+                absolutepath = urllib.quote(path + '/' + pathname)
             revid = entry.revision
 
             file = util.Container(
@@ -146,7 +146,8 @@
                 revno_url = 'head:'
             else:
                 revno_url = history.get_revno(revid)
-            history.add_branch_nicks(change)
+            # add parent & merge-point branch-nick info, in case it's useful
+            history.get_branch_nicks([ change ])
 
             # Create breadcrumb trail for the path within the branch
             branch_breadcrumbs = util.branch_breadcrumbs(path, rev_tree, 'files')

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2009-08-04 04:08:03 +0000
+++ loggerhead/controllers/revision_ui.py	2009-02-18 01:00:02 +0000
@@ -17,29 +17,139 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-try:
-    import simplejson
-except ImportError:
-    import json as simplejson
-import urllib
+from StringIO import StringIO
+
+import bzrlib.diff
 
 from paste.httpexceptions import HTTPServerError
 
 from loggerhead import util
 from loggerhead.controllers import TemplatedBranchView
-from loggerhead.controllers.filediff_ui import diff_chunks_for_file
+from loggerhead.history import rich_filename
 
 
 DEFAULT_LINE_COUNT_LIMIT = 3000
 
-def dq(p):
-    return urllib.quote(urllib.quote(p, safe=''))
-
 
 class RevisionUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.revision'
 
+    def _process_diff(self, diff):
+        # doesn't really need to be a method; could be static.
+        chunks = []
+        chunk = None
+        for line in diff.splitlines():
+            if len(line) == 0:
+                continue
+            if line.startswith('+++ ') or line.startswith('--- '):
+                continue
+            if line.startswith('@@ '):
+                # new chunk
+                if chunk is not None:
+                    chunks.append(chunk)
+                chunk = util.Container()
+                chunk.diff = []
+                split_lines = line.split(' ')[1:3]
+                lines = [int(x.split(',')[0][1:]) for x in split_lines]
+                old_lineno = lines[0]
+                new_lineno = lines[1]
+            elif line.startswith(' '):
+                chunk.diff.append(util.Container(old_lineno=old_lineno,
+                                                 new_lineno=new_lineno,
+                                                 type='context',
+                                                 line=line[1:]))
+                old_lineno += 1
+                new_lineno += 1
+            elif line.startswith('+'):
+                chunk.diff.append(util.Container(old_lineno=None,
+                                                 new_lineno=new_lineno,
+                                                 type='insert', line=line[1:]))
+                new_lineno += 1
+            elif line.startswith('-'):
+                chunk.diff.append(util.Container(old_lineno=old_lineno,
+                                                 new_lineno=None,
+                                                 type='delete', line=line[1:]))
+                old_lineno += 1
+            else:
+                chunk.diff.append(util.Container(old_lineno=None,
+                                                 new_lineno=None,
+                                                 type='unknown',
+                                                 line=repr(line)))
+        if chunk is not None:
+            chunks.append(chunk)
+        return chunks
+
+    def _parse_diffs(self, old_tree, new_tree, delta):
+        """
+        Return a list of processed diffs, in the format::
+
+            list(
+                filename: str,
+                file_id: str,
+                chunks: list(
+                    diff: list(
+                        old_lineno: int,
+                        new_lineno: int,
+                        type: str('context', 'delete', or 'insert'),
+                        line: str,
+                    ),
+                ),
+            )
+        """
+        process = []
+        out = []
+
+        for old_path, new_path, fid, \
+            kind, text_modified, meta_modified in delta.renamed:
+            if text_modified:
+                process.append((old_path, new_path, fid, kind))
+        for path, fid, kind, text_modified, meta_modified in delta.modified:
+            process.append((path, path, fid, kind))
+
+        for old_path, new_path, fid, kind in process:
+            old_lines = old_tree.get_file_lines(fid)
+            new_lines = new_tree.get_file_lines(fid)
+            buffer = StringIO()
+            if old_lines != new_lines:
+                try:
+                    bzrlib.diff.internal_diff(old_path, old_lines,
+                                              new_path, new_lines, buffer)
+                except bzrlib.errors.BinaryFile:
+                    diff = ''
+                else:
+                    diff = buffer.getvalue()
+            else:
+                diff = ''
+            out.append(util.Container(
+                          filename=rich_filename(new_path, kind),
+                          file_id=fid,
+                          chunks=self._process_diff(diff),
+                          raw_diff=diff))
+
+        return out
+
+    def get_change_with_diff(self, revid, compare_revid):
+        h = self._history
+        change = h.get_changes([revid])[0]
+
+        if compare_revid is None:
+            if change.parents:
+                compare_revid = change.parents[0].revid
+            else:
+                compare_revid = 'null:'
+
+        rev_tree1 = h._branch.repository.revision_tree(compare_revid)
+        rev_tree2 = h._branch.repository.revision_tree(revid)
+        delta = rev_tree2.changes_from(rev_tree1)
+
+        change.changes = h.parse_delta(delta)
+        change.changes.modified = self._parse_diffs(rev_tree1,
+                                                    rev_tree2,
+                                                    delta)
+
+        return change
+
     def get_values(self, path, kwargs, headers):
         h = self._history
         revid = self.get_revid()
@@ -67,45 +177,15 @@
             navigation.query = query
         util.fill_in_navigation(navigation)
 
-        change = h.get_changes([revid])[0]
-
-        if compare_revid is None:
-            file_changes = h.get_file_changes(change)
-        else:
-            file_changes = h.file_changes_for_revision_ids(
-                compare_revid, change.revid)
-
-        if path in ('', '/'):
-            path = None
-
-        link_data = {}
-        path_to_id = {}
-        if path:
-            item = [x for x in file_changes.text_changes if x.filename == path][0]
-            diff_chunks = diff_chunks_for_file(
-                self._history._branch.repository, item.file_id,
-                item.old_revision, item.new_revision)
-        else:
-            diff_chunks = None
-            for i, item in enumerate(file_changes.text_changes):
-                item.index = i
-                link_data['diff-' + str(i)] = '%s/%s/%s' % (
-                    dq(item.new_revision), dq(item.old_revision), dq(item.file_id))
-                path_to_id[item.filename] = 'diff-' + str(i)
-
-        h.add_branch_nicks(change)
-
-        if '.' in change.revno:
-            # Walk "up" though the merge-sorted graph until we find a
-            # revision with merge depth 0: this is the revision that merged
-            # this one to mainline.
-            ri = self._history._rev_info
-            i = self._history._rev_indices[change.revid]
-            while ri[i][0][2] > 0:
-                i -= 1
-            merged_in = ri[i][0][3]
-        else:
-            merged_in = None
+        change = self.get_change_with_diff(revid, compare_revid)
+        # add parent & merge-point branch-nick info, in case it's useful
+        h.get_branch_nicks([change])
+
+        line_count_limit = DEFAULT_LINE_COUNT_LIMIT
+        line_count = 0
+        for file in change.changes.modified:
+            for chunk in file.chunks:
+                line_count += len(chunk.diff)
 
         # Directory Breadcrumbs
         directory_breadcrumbs = (
@@ -118,21 +198,17 @@
             'branch': self._branch,
             'revid': revid,
             'change': change,
-            'file_changes': file_changes,
-            'diff_chunks': diff_chunks,
-            'link_data': simplejson.dumps(link_data),
-            'specific_path': path,
-            'json_specific_path': simplejson.dumps(path),
-            'path_to_id': simplejson.dumps(path_to_id),
             'start_revid': start_revid,
             'filter_file_id': filter_file_id,
             'util': util,
             'history': h,
-            'merged_in': merged_in,
             'navigation': navigation,
             'query': query,
             'remember': remember,
             'compare_revid': compare_revid,
             'url': self._branch.context_url,
+            'line_count': line_count,
+            'line_count_limit': line_count_limit,
+            'show_plain_diffs': line_count > line_count_limit,
             'directory_breadcrumbs': directory_breadcrumbs,
         }

=== removed file 'loggerhead/controllers/revlog_ui.py'
--- loggerhead/controllers/revlog_ui.py	2009-03-19 00:44:05 +0000
+++ loggerhead/controllers/revlog_ui.py	1970-01-01 00:00:00 +0000
@@ -1,27 +0,0 @@
-import urllib
-
-from loggerhead import util
-from loggerhead.controllers import TemplatedBranchView
-
-
-class RevLogUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.revlog'
-
-    def get_values(self, path, kwargs, headers):
-        history = self._history
-
-        revid = urllib.unquote(self.args[0])
-
-        change = history.get_changes([revid])[0]
-        file_changes = history.get_file_changes(change)
-        history.add_branch_nicks(change)
-
-        return {
-            'branch': self._branch,
-            'entry': change,
-            'file_changes': file_changes,
-            'util': util,
-            'revid': revid,
-            'url': self._branch.context_url,
-        }

=== modified file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	2009-05-13 14:03:48 +0000
+++ loggerhead/daemon.py	2008-12-07 15:24:05 +0000
@@ -53,7 +53,7 @@
             pass
 
     f = open(pidfile, 'w')
-    f.write('%d\n' % (os.getpid(),))
+    f.write('%d\n' % os.getpid())
     f.close()
 
 

=== modified file 'loggerhead/highlight.py'
--- loggerhead/highlight.py	2009-05-16 06:03:47 +0000
+++ loggerhead/highlight.py	2009-03-02 00:42:46 +0000
@@ -24,18 +24,25 @@
 DEFAULT_PYGMENT_STYLE = 'colorful'
 
 
-def highlight(path, text, encoding, style=DEFAULT_PYGMENT_STYLE):
+def highlight(path, text, style=DEFAULT_PYGMENT_STYLE):
     """
     Returns a list of highlighted (i.e. HTML formatted) strings.
     """
 
     formatter = HtmlFormatter(style=style, nowrap=True, classprefix='pyg-')
 
-    try:
-        lexer = guess_lexer_for_filename(path, text[:1024], encoding=encoding)
+    encoding = 'utf-8'
+    try:
+        text = text.decode(encoding)
+    except UnicodeDecodeError:
+        encoding = 'iso-8859-15'
+        text = text.decode(encoding)
+
+    try:
+        lexer = guess_lexer_for_filename(path, text, encoding=encoding)
     except (ClassNotFound, ValueError):
         try:
-            lexer = guess_lexer(text[:1024], encoding=encoding)
+            lexer = guess_lexer(text, encoding=encoding)
         except (ClassNotFound, ValueError):
             lexer = TextLexer(encoding=encoding)
 

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2009-10-17 08:59:33 +0000
+++ loggerhead/history.py	2009-02-26 18:10:29 +0000
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2008, 2009 Canonical Ltd.
+# Copyright (C) 2008  Canonical Ltd.
 #                     (Authored by Martin Albisetti <argentina@gmail.com>)
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
 # Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
@@ -33,16 +33,39 @@
 import logging
 import re
 import textwrap
-
+import threading
+import time
+import urllib
+from StringIO import StringIO
+
+from loggerhead import search
+from loggerhead import util
+from loggerhead.wholehistory import compute_whole_history_data
+
+import bzrlib
 import bzrlib.branch
-import bzrlib.delta
+import bzrlib.diff
 import bzrlib.errors
+import bzrlib.progress
 import bzrlib.revision
-
-from loggerhead import search
-from loggerhead import util
-from loggerhead.wholehistory import compute_whole_history_data
-
+import bzrlib.textfile
+import bzrlib.tsort
+import bzrlib.ui
+
+# bzrlib's UIFactory is not thread-safe
+uihack = threading.local()
+
+
+class ThreadSafeUIFactory (bzrlib.ui.SilentUIFactory):
+
+    def nested_progress_bar(self):
+        if getattr(uihack, '_progress_bar_stack', None) is None:
+            pbs = bzrlib.progress.ProgressBarStack(
+                      klass=bzrlib.progress.DummyProgress)
+            uihack._progress_bar_stack = pbs
+        return uihack._progress_bar_stack.get_nested()
+
+bzrlib.ui.ui_factory = ThreadSafeUIFactory()
 
 def is_branch(folder):
     try:
@@ -86,6 +109,9 @@
     return path
 
 
+# from bzrlib
+
+
 class _RevListToTimestamps(object):
     """This takes a list of revisions, and allows you to bisect by date"""
 
@@ -103,92 +129,8 @@
     def __len__(self):
         return len(self.revid_list)
 
-class FileChangeReporter(object):
-
-    def __init__(self, old_inv, new_inv):
-        self.added = []
-        self.modified = []
-        self.renamed = []
-        self.removed = []
-        self.text_changes = []
-        self.old_inv = old_inv
-        self.new_inv = new_inv
-
-    def revid(self, inv, file_id):
-        try:
-            return inv[file_id].revision
-        except bzrlib.errors.NoSuchId:
-            return 'null:'
-
-    def report(self, file_id, paths, versioned, renamed, modified,
-               exe_change, kind):
-        if modified not in ('unchanged', 'kind changed'):
-            if versioned == 'removed':
-                filename = rich_filename(paths[0], kind[0])
-            else:
-                filename = rich_filename(paths[1], kind[1])
-            self.text_changes.append(util.Container(
-                filename=filename, file_id=file_id,
-                old_revision=self.revid(self.old_inv, file_id),
-                new_revision=self.revid(self.new_inv, file_id)))
-        if versioned == 'added':
-            self.added.append(util.Container(
-                filename=rich_filename(paths[1], kind),
-                file_id=file_id, kind=kind[1]))
-        elif versioned == 'removed':
-            self.removed.append(util.Container(
-                filename=rich_filename(paths[0], kind),
-                file_id=file_id, kind=kind[0]))
-        elif renamed:
-            self.renamed.append(util.Container(
-                old_filename=rich_filename(paths[0], kind[0]),
-                new_filename=rich_filename(paths[1], kind[1]),
-                file_id=file_id,
-                text_modified=modified == 'modified'))
-        else:
-            self.modified.append(util.Container(
-                filename=rich_filename(paths[1], kind),
-                file_id=file_id))
-
-
-class RevInfoMemoryCache(object):
-    """A store that validates values against the revids they were stored with.
-
-    We use a unique key for each branch.
-
-    The reason for not just using the revid as the key is so that when a new
-    value is provided for a branch, we replace the old value used for the
-    branch.
-
-    There is another implementation of the same interface in
-    loggerhead.changecache.RevInfoDiskCache.
-    """
-
-    def __init__(self, cache):
-        self._cache = cache
-
-    def get(self, key, revid):
-        """Return the data associated with `key`, subject to a revid check.
-
-        If a value was stored under `key`, with the same revid, return it.
-        Otherwise return None.
-        """
-        cached = self._cache.get(key)
-        if cached is None:
-            return None
-        stored_revid, data = cached
-        if revid == stored_revid:
-            return data
-        else:
-            return None
-
-    def set(self, key, revid, data):
-        """Store `data` under `key`, to be checked against `revid` on get().
-        """
-        self._cache[key] = (revid, data)
-
-
-class History(object):
+
+class History (object):
     """Decorate a branch to provide information for rendering.
 
     History objects are expected to be short lived -- when serving a request
@@ -196,80 +138,31 @@
     around it, serve the request, throw the History object away, unlock the
     branch and throw it away.
 
-    :ivar _file_change_cache: An object that caches information about the
-        files that changed between two revisions.
-    :ivar _rev_info: A list of information about revisions.  This is by far
-        the most cryptic data structure in loggerhead.  At the top level, it
-        is a list of 3-tuples [(merge-info, where-merged, parents)].
-        `merge-info` is (seq, revid, merge_depth, revno_str, end_of_merge) --
-        like a merged sorted list, but the revno is stringified.
-        `where-merged` is a tuple of revisions that have this revision as a
-        non-lefthand parent.  Finally, `parents` is just the usual list of
-        parents of this revision.
-    :ivar _rev_indices: A dictionary mapping each revision id to the index of
-        the information about it in _rev_info.
-    :ivar _revno_revid: A dictionary mapping stringified revnos to revision
-        ids.
+    :ivar _file_change_cache: xx
     """
 
-    def _load_whole_history_data(self, caches, cache_key):
-        """Set the attributes relating to the whole history of the branch.
-
-        :param caches: a list of caches with interfaces like
-            `RevInfoMemoryCache` and be ordered from fastest to slowest.
-        :param cache_key: the key to use with the caches.
-        """
-        self._rev_indices = None
-        self._rev_info = None
-
-        missed_caches = []
-        def update_missed_caches():
-            for cache in missed_caches:
-                cache.set(cache_key, self.last_revid, self._rev_info)
-        for cache in caches:
-            data = cache.get(cache_key, self.last_revid)
-            if data is not None:
-                self._rev_info = data
-                update_missed_caches()
-                break
-            else:
-                missed_caches.append(cache)
-        else:
-            whole_history_data = compute_whole_history_data(self._branch)
-            self._rev_info, self._rev_indices = whole_history_data
-            update_missed_caches()
-
-        if self._rev_indices is not None:
-            self._revno_revid = {}
-            for ((_, revid, _, revno_str, _), _, _) in self._rev_info:
-                self._revno_revid[revno_str] = revid
-        else:
-            self._revno_revid = {}
-            self._rev_indices = {}
-            for ((seq, revid, _, revno_str, _), _, _) in self._rev_info:
-                self._rev_indices[revid] = seq
-                self._revno_revid[revno_str] = revid
-
-    def __init__(self, branch, whole_history_data_cache, file_cache=None,
-                 revinfo_disk_cache=None, cache_key=None):
+    def __init__(self, branch, whole_history_data_cache):
         assert branch.is_locked(), (
             "Can only construct a History object with a read-locked branch.")
-        if file_cache is not None:
-            self._file_change_cache = file_cache
-            file_cache.history = self
-        else:
-            self._file_change_cache = None
+        self._file_change_cache = None
         self._branch = branch
         self._inventory_cache = {}
         self._branch_nick = self._branch.get_config().get_nickname()
-        self.log = logging.getLogger('loggerhead.%s' % (self._branch_nick,))
+        self.log = logging.getLogger('loggerhead.%s' % self._branch_nick)
 
         self.last_revid = branch.last_revision()
 
-        caches = [RevInfoMemoryCache(whole_history_data_cache)]
-        if revinfo_disk_cache:
-            caches.append(revinfo_disk_cache)
-        self._load_whole_history_data(caches, cache_key)
+        whole_history_data = whole_history_data_cache.get(self.last_revid)
+        if whole_history_data is None:
+            whole_history_data = compute_whole_history_data(branch)
+            whole_history_data_cache[self.last_revid] = whole_history_data
+
+        (self._revision_graph, self._full_history, self._revision_info,
+         self._revno_revid, self._merge_sort, self._where_merged,
+         ) = whole_history_data
+
+    def use_file_cache(self, cache):
+        self._file_change_cache = cache
 
     @property
     def has_revisions(self):
@@ -279,12 +172,12 @@
         return self._branch.get_config()
 
     def get_revno(self, revid):
-        if revid not in self._rev_indices:
+        if revid not in self._revision_info:
             # ghost parent?
             return 'unknown'
-        seq = self._rev_indices[revid]
-        revno = self._rev_info[seq][0][3]
-        return revno
+        (seq, revid, merge_depth,
+         revno_str, end_of_merge) = self._revision_info[revid]
+        return revno_str
 
     def get_revids_from(self, revid_list, start_revid):
         """
@@ -292,25 +185,24 @@
         revid in revid_list.
         """
         if revid_list is None:
-            revid_list = [r[0][1] for r in self._rev_info]
+            revid_list = self._full_history
         revid_set = set(revid_list)
         revid = start_revid
 
         def introduced_revisions(revid):
             r = set([revid])
-            seq = self._rev_indices[revid]
-            md = self._rev_info[seq][0][2]
+            seq, revid, md, revno, end_of_merge = self._revision_info[revid]
             i = seq + 1
-            while i < len(self._rev_info) and self._rev_info[i][0][2] > md:
-                r.add(self._rev_info[i][0][1])
+            while i < len(self._merge_sort) and self._merge_sort[i][2] > md:
+                r.add(self._merge_sort[i][1])
                 i += 1
             return r
-        while True:
+        while 1:
             if bzrlib.revision.is_null(revid):
                 return
             if introduced_revisions(revid) & revid_set:
                 yield revid
-            parents = self._rev_info[self._rev_indices[revid]][2]
+            parents = self._revision_graph[revid]
             if len(parents) == 0:
                 return
             revid = parents[0]
@@ -318,17 +210,25 @@
     def get_short_revision_history_by_fileid(self, file_id):
         # FIXME: would be awesome if we could get, for a folder, the list of
         # revisions where items within that folder changed.i
-        possible_keys = [(file_id, revid) for revid in self._rev_indices]
-        get_parent_map = self._branch.repository.texts.get_parent_map
-        # We chunk the requests as this works better with GraphIndex.
-        # See _filter_revisions_touching_file_id in bzrlib/log.py
-        # for more information.
-        revids = []
-        chunk_size = 1000
-        for start in xrange(0, len(possible_keys), chunk_size):
-            next_keys = possible_keys[start:start + chunk_size]
-            revids += [k[1] for k in get_parent_map(next_keys)]
-        del possible_keys, next_keys
+        try:
+            # FIXME: Workaround for bzr versions prior to 1.6b3.
+            # Remove me eventually pretty please  :)
+            w = self._branch.repository.weave_store.get_weave(
+                    file_id, self._branch.repository.get_transaction())
+            w_revids = w.versions()
+            revids = [r for r in self._full_history if r in w_revids]
+        except AttributeError:
+            possible_keys = [(file_id, revid) for revid in self._full_history]
+            get_parent_map = self._branch.repository.texts.get_parent_map
+            # We chunk the requests as this works better with GraphIndex.
+            # See _filter_revisions_touching_file_id in bzrlib/log.py
+            # for more information.
+            revids = []
+            chunk_size = 1000
+            for start in xrange(0, len(possible_keys), chunk_size):
+                next_keys = possible_keys[start:start + chunk_size]
+                revids += [k[1] for k in get_parent_map(next_keys)]
+            del possible_keys, next_keys
         return revids
 
     def get_revision_history_since(self, revid_list, date):
@@ -519,10 +419,10 @@
 
         merge_point = []
         while True:
-            children = self._rev_info[self._rev_indices[revid]][1]
+            children = self._where_merged.get(revid, [])
             nexts = []
             for child in children:
-                child_parents = self._rev_info[self._rev_indices[child]][2]
+                child_parents = self._revision_graph[child]
                 if child_parents[0] == revid:
                     nexts.append(child)
                 else:
@@ -548,37 +448,40 @@
             revnol = revno.split(".")
             revnos = ".".join(revnol[:-2])
             revnolast = int(revnol[-1])
-            if revnos in d:
+            if revnos in d.keys():
                 m = d[revnos][0]
                 if revnolast < m:
                     d[revnos] = (revnolast, revid)
             else:
                 d[revnos] = (revnolast, revid)
 
-        return [revid for (_, revid) in d.itervalues()]
+        return [d[revnos][1] for revnos in d.keys()]
 
-    def add_branch_nicks(self, change):
+    def get_branch_nicks(self, changes):
         """
-        given a 'change', fill in the branch nicks on all parents and merge
-        points.
+        given a list of changes from L{get_changes}, fill in the branch nicks
+        on all parents and merge points.
         """
         fetch_set = set()
-        for p in change.parents:
-            fetch_set.add(p.revid)
-        for p in change.merge_points:
-            fetch_set.add(p.revid)
+        for change in changes:
+            for p in change.parents:
+                fetch_set.add(p.revid)
+            for p in change.merge_points:
+                fetch_set.add(p.revid)
         p_changes = self.get_changes(list(fetch_set))
         p_change_dict = dict([(c.revid, c) for c in p_changes])
-        for p in change.parents:
-            if p.revid in p_change_dict:
-                p.branch_nick = p_change_dict[p.revid].branch_nick
-            else:
-                p.branch_nick = '(missing)'
-        for p in change.merge_points:
-            if p.revid in p_change_dict:
-                p.branch_nick = p_change_dict[p.revid].branch_nick
-            else:
-                p.branch_nick = '(missing)'
+        for change in changes:
+            # arch-converted branches may not have merged branch info :(
+            for p in change.parents:
+                if p.revid in p_change_dict:
+                    p.branch_nick = p_change_dict[p.revid].branch_nick
+                else:
+                    p.branch_nick = '(missing)'
+            for p in change.merge_points:
+                if p.revid in p_change_dict:
+                    p.branch_nick = p_change_dict[p.revid].branch_nick
+                else:
+                    p.branch_nick = '(missing)'
 
     def get_changes(self, revid_list):
         """Return a list of changes objects for the given revids.
@@ -623,53 +526,75 @@
 
         return [self._change_from_revision(rev) for rev in rev_list]
 
+    def _get_deltas_for_revisions_with_trees(self, revisions):
+        """Produce a list of revision deltas.
+
+        Note that the input is a sequence of REVISIONS, not revision_ids.
+        Trees will be held in memory until the generator exits.
+        Each delta is relative to the revision's lefthand predecessor.
+        (This is copied from bzrlib.)
+        """
+        required_trees = set()
+        for revision in revisions:
+            required_trees.add(revision.revid)
+            required_trees.update([p.revid for p in revision.parents[:1]])
+        trees = dict((t.get_revision_id(), t) for
+                     t in self._branch.repository.revision_trees(
+                         required_trees))
+        ret = []
+        for revision in revisions:
+            if not revision.parents:
+                old_tree = self._branch.repository.revision_tree(
+                    bzrlib.revision.NULL_REVISION)
+            else:
+                old_tree = trees[revision.parents[0].revid]
+            tree = trees[revision.revid]
+            ret.append(tree.changes_from(old_tree))
+        return ret
+
     def _change_from_revision(self, revision):
         """
         Given a bzrlib Revision, return a processed "change" for use in
         templates.
         """
+        commit_time = datetime.datetime.fromtimestamp(revision.timestamp)
+
+        parents = [util.Container(revid=r,
+                   revno=self.get_revno(r)) for r in revision.parent_ids]
+
         message, short_message = clean_message(revision.message)
 
-        tags = self._branch.tags.get_reverse_tag_dict()
-
-        revtags = None
-        if tags.has_key(revision.revision_id):
-          revtags = ', '.join(tags[revision.revision_id])
-
         entry = {
             'revid': revision.revision_id,
-            'date': datetime.datetime.fromtimestamp(revision.timestamp),
-            'utc_date': datetime.datetime.utcfromtimestamp(revision.timestamp),
-            'authors': revision.get_apparent_authors(),
+            'date': commit_time,
+            'author': revision.get_apparent_author(),
             'branch_nick': revision.properties.get('branch-nick', None),
             'short_comment': short_message,
             'comment': revision.message,
             'comment_clean': [util.html_clean(s) for s in message],
             'parents': revision.parent_ids,
-            'bugs': [bug.split()[0] for bug in revision.properties.get('bugs', '').splitlines()],
-            'tags': revtags,
         }
         return util.Container(entry)
 
-    def get_file_changes_uncached(self, entry):
-        if entry.parents:
-            old_revid = entry.parents[0].revid
-        else:
-            old_revid = bzrlib.revision.NULL_REVISION
-        return self.file_changes_for_revision_ids(old_revid, entry.revid)
-
-    def get_file_changes(self, entry):
+    def get_file_changes_uncached(self, entries):
+        delta_list = self._get_deltas_for_revisions_with_trees(entries)
+
+        return [self.parse_delta(delta) for delta in delta_list]
+
+    def get_file_changes(self, entries):
         if self._file_change_cache is None:
-            return self.get_file_changes_uncached(entry)
+            return self.get_file_changes_uncached(entries)
         else:
-            return self._file_change_cache.get_file_changes(entry)
-
-    def add_changes(self, entry):
-        changes = self.get_file_changes(entry)
-        entry.changes = changes
+            return self._file_change_cache.get_file_changes(entries)
+
+    def add_changes(self, entries):
+        changes_list = self.get_file_changes(entries)
+
+        for entry, changes in zip(entries, changes_list):
+            entry.changes = changes
 
     def get_file(self, file_id, revid):
-        """Returns (path, filename, file contents)"""
+        "returns (path, filename, data)"
         inv = self.get_inventory(revid)
         inv_entry = inv[file_id]
         rev_tree = self._branch.repository.revision_tree(inv_entry.revision)
@@ -678,7 +603,7 @@
             path = '/' + path
         return path, inv_entry.name, rev_tree.get_file_text(file_id)
 
-    def file_changes_for_revision_ids(self, old_revid, new_revid):
+    def parse_delta(self, delta):
         """
         Return a nested data structure containing the changes in a delta::
 
@@ -688,24 +613,30 @@
             modified: list(
                 filename: str,
                 file_id: str,
-            ),
-            text_changes: list((filename, file_id)),
+            )
         """
-        repo = self._branch.repository
-        if (bzrlib.revision.is_null(old_revid) or
-            bzrlib.revision.is_null(new_revid)):
-            old_tree, new_tree = map(
-                repo.revision_tree, [old_revid, new_revid])
-        else:
-            old_tree, new_tree = repo.revision_trees([old_revid, new_revid])
-
-        reporter = FileChangeReporter(old_tree.inventory, new_tree.inventory)
-
-        bzrlib.delta.report_changes(new_tree.iter_changes(old_tree), reporter)
-
-        return util.Container(
-            added=sorted(reporter.added, key=lambda x: x.filename),
-            renamed=sorted(reporter.renamed, key=lambda x: x.new_filename),
-            removed=sorted(reporter.removed, key=lambda x: x.filename),
-            modified=sorted(reporter.modified, key=lambda x: x.filename),
-            text_changes=sorted(reporter.text_changes, key=lambda x: x.filename))
+        added = []
+        modified = []
+        renamed = []
+        removed = []
+
+        for path, fid, kind in delta.added:
+            added.append((rich_filename(path, kind), fid))
+
+        for path, fid, kind, text_modified, meta_modified in delta.modified:
+            modified.append(util.Container(filename=rich_filename(path, kind),
+                                           file_id=fid))
+
+        for old_path, new_path, fid, kind, text_modified, meta_modified in \
+delta.renamed:
+            renamed.append((rich_filename(old_path, kind),
+                            rich_filename(new_path, kind), fid))
+            if meta_modified or text_modified:
+                modified.append(util.Container(
+                    filename=rich_filename(new_path, kind), file_id=fid))
+
+        for path, fid, kind in delta.removed:
+            removed.append((rich_filename(path, kind), fid))
+
+        return util.Container(added=added, renamed=renamed,
+                              removed=removed, modified=modified)

=== added file 'loggerhead/lockfile.py'
--- loggerhead/lockfile.py	1970-01-01 00:00:00 +0000
+++ loggerhead/lockfile.py	2008-10-24 02:26:05 +0000
@@ -0,0 +1,84 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+import os
+import threading
+import time
+
+from loggerhead import util
+
+
+with_lock = util.with_lock('_tlock', 'LockFile')
+
+MAX_STALE_TIME = 5 * 60
+
+
+class LockFile (object):
+    """
+    simple lockfile implementation that mimics the API of threading.Lock, so
+    it can be used interchangably.  it's actually a reentrant lock, so the
+    lock may be acquired multiple times by the same thread, as long as it's
+    released an equal number of times.  unlike threading.Lock, this lock can
+    be used across processes.
+
+    this uses os.open(O_CREAT|O_EXCL), which apparently works even on windows,
+    but will not work over NFS, if anyone still uses that.  so don't put the
+    cache folder on an NFS server...
+    """
+
+    def __init__(self, filename):
+        self._filename = filename
+        # thread lock to maintain internal consistency
+        self._tlock = threading.Lock()
+        self._count = 0
+        if os.path.exists(filename):
+            # remove stale locks left over from a previous run
+            if time.time() - os.stat(filename).st_mtime > MAX_STALE_TIME:
+                os.remove(filename)
+
+    @with_lock
+    def _try_acquire(self):
+        if self._count > 0:
+            self._count += 1
+            return True
+        try:
+            fd = os.open(self._filename,
+                         os.O_WRONLY | os.O_CREAT | os.O_EXCL, 0600)
+            os.close(fd)
+            self._count += 1
+            return True
+        except OSError:
+            return False
+
+    def acquire(self):
+        # try over and over, sleeping on exponential backoff with
+        # an upper limit of about 5 seconds
+        pause = 0.1
+        #max_pause = 5.0
+        max_pause = 0.1
+        while True:
+            if self._try_acquire():
+                return
+            time.sleep(pause)
+            pause = min(pause * 2.0, max_pause)
+
+    @with_lock
+    def release(self):
+        self._count -= 1
+        if self._count == 0:
+            os.remove(self._filename)

=== modified file 'loggerhead/lsprof.py'
--- loggerhead/lsprof.py	2009-07-07 23:52:24 +0000
+++ loggerhead/lsprof.py	2008-10-24 02:26:05 +0000
@@ -73,6 +73,7 @@
             d = d[:top]
         cols = "% 12s %12s %11.4f %11.4f   %s\n"
         hcols = "% 12s %12s %12s %12s %s\n"
+        cols2 = "+%12s %12s %11.4f %11.4f +  %s\n"
         file.write(hcols % ("CallCount", "Recursive", "Total(ms)",
                             "Inline(ms)", "module:lineno(function)"))
         for e in d:

=== modified file 'loggerhead/middleware/profile.py'
--- loggerhead/middleware/profile.py	2009-10-17 08:47:38 +0000
+++ loggerhead/middleware/profile.py	2008-11-14 06:48:20 +0000
@@ -1,12 +1,11 @@
-"""Profiling middleware for Paste."""
-
+'''Profiling middleware for paste.'''
+import cgi
 import threading
 
 from bzrlib.lsprof import profile
 
-
 class LSProfMiddleware(object):
-    """Paste middleware for profiling with lsprof."""
+    '''Paste middleware for profiling with lsprof.'''
 
     def __init__(self, app, global_conf=None):
         self.app = app
@@ -27,7 +26,8 @@
         try:
             ret, stats = profile(self.__run_app, environ, start_response)
             self.__count += 1
-            stats.save("%d-stats.callgrind" % (self.__count,), format="callgrind")
+            stats.save("%d-stats.callgrind" % self.__count, format="callgrind")
             return ret
         finally:
             self.lock.release()
+

=== modified file 'loggerhead/search.py'
--- loggerhead/search.py	2009-04-17 03:38:04 +0000
+++ loggerhead/search.py	2008-11-05 00:50:06 +0000
@@ -17,18 +17,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-
-_mod_index = None
-def import_search():
-    global errors, _mod_index, FileTextHit, RevisionHit
-    if _mod_index is not None:
-        return
-    try:
-        from bzrlib.plugins.search import errors
-        from bzrlib.plugins.search import index as _mod_index
-        from bzrlib.plugins.search.index import FileTextHit, RevisionHit
-    except ImportError:
-        _mod_index = None
+import sets
+try:
+    from bzrlib.plugins.search import errors
+    from bzrlib.plugins.search import index as _mod_index
+    from bzrlib.plugins.search.index import FileTextHit, RevisionHit
+except ImportError:
+    _mod_index = None
 
 
 def search_revisions(branch, query_list, suggest=False):
@@ -41,7 +36,6 @@
     param suggest: Optional flag to request suggestions instead of results
     return: A list for results, either revision ids or terms
     """
-    import_search()
     if _mod_index is None:
         return None # None indicates could-not-search
     try:
@@ -65,6 +59,6 @@
                     revid_list.append(result.text_key[1])
                 elif isinstance(result, RevisionHit):
                     revid_list.append(result.revision_key[0])
-            return list(set(revid_list))
+            return list(sets.Set(revid_list))
     finally:
         index._branch.unlock()

=== modified file 'loggerhead/static/css/diff.css'
--- loggerhead/static/css/diff.css	2009-06-17 20:28:20 +0000
+++ loggerhead/static/css/diff.css	2009-02-26 20:55:46 +0000
@@ -31,7 +31,7 @@
     width:493px;
     margin:0px 0px 5px 0px;
 }
-.information, .committer, .timer, .mfrom, .mto, .revid, .bug, .tags {
+.information, .committer, .timer, .mfrom, .mto, .revid {
     clear:both;
     margin:0px;
     padding:0px 0px 2px 18px;
@@ -43,11 +43,6 @@
     padding:1px 0px 0px 18px;
     margin:0px 10px 5px 0px;
 }
-.tags {
-    padding:1px 0px 0px 18px;
-    margin:0px 10px 5px 0px;
-    background:url(../images/ico_tag.gif) no-repeat top left;
-}
 .committer, .mfrom, .mto {
     color:#000;
     padding:1px 0px 0px 18px;
@@ -70,14 +65,6 @@
 .mto {
     background:url(../images/ico_mergeto.gif) no-repeat top left;
 }
-.bug {
-    padding:1px 0px 0px 18px;
-    margin:0px 10px 5px 0px;
-    float:left;
-    clear:none;
-    display:inline;
-    background:url(../images/ico_bug.png) no-repeat top left;
-}
 /**/
 #loggerheadCont p.expand, #loggerheadCont p.expand a, #loggerheadCont p.expand a:link, #loggerheadCont p.expand a:visited, #loggerheadCont p.expand a:hover {
     color:#0f6b97;

=== modified file 'loggerhead/static/css/files.css'
--- loggerhead/static/css/files.css	2009-06-17 20:28:20 +0000
+++ loggerhead/static/css/files.css	2009-01-23 20:53:40 +0000
@@ -1,5 +1,5 @@
 /*Info Box*/
-.information, .committer, .timer, .mfrom, .mto, .revid, .bug, .tags {
+.information, .committer, .timer, .mfrom, .mto, .revid {
 	float:left;
 	margin:0px 10px 5px 0px;
 	padding:0px 0px 2px 18px;
@@ -12,12 +12,6 @@
     padding:1px 0px 0px 18px;
     margin:0px 10px 5px 0px;
 }
-.tags {
-    float:left;
-    padding:1px 0px 0px 18px;
-    margin:0px 10px 5px 0px;
-    background:url(../images/ico_tag.gif) no-repeat top left;
-}
 .comiter, .mfrom, .mto {
 	color:#000;
 	padding:1px 0px 0px 18px;
@@ -45,6 +39,3 @@
     width:100%;
     position:relative;
 }
-.bug {
-	background:url(../images/ico_bug.png) no-repeat top left;
-}

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2009-06-11 21:16:27 +0000
+++ loggerhead/static/css/global.css	2009-03-02 01:32:36 +0000
@@ -11,9 +11,6 @@
 	font-weight:normal;
 	outline:none;
 }
-b a:link, b a:visited {
-    font-weight: bold;
-}
 img {
 	padding:0px;
 	margin:0px;
@@ -230,19 +227,13 @@
 .expandcell, .expcell {
 	width:28px;	
 }
-.summarycell, .authorcell, .tagscell, .datecell, .timedate{
+.summarycell, .authorcell, .datecell, .timedate{
   padding: 4px 8px;
   border: 1px solid #d2d2d2;
 }
 .icocell {
   width: 18px;
 }
-.authorcell, .autcell {
-  width: 240px;
-}
-.tagscell, .tagcell {
-  width: 240px;
-}
 .datecell, .date {
   width: 180px;
 }
@@ -252,7 +243,7 @@
 .downloadcell, .downr {
 	width:47px;
 }
-.revnro, .expcell, .diffr, .summcell, .autcell, .tagcell, .icocell, .date, .downr, .allicones, .timedate2 {
+.revnro, .expcell, .diffr, .summcell, .autcell, .icocell, .date, .downr, .allicones, .timedate2 {
   border: 0;
   padding: 4px 4px;
   border-bottom:1px solid #d2d2d2;
@@ -351,4 +342,4 @@
 }
 .revision_log {
     overflow: hidden;
-}
+}
\ No newline at end of file

=== removed file 'loggerhead/static/images/ico_bug.png'
Binary files loggerhead/static/images/ico_bug.png and loggerhead/static/images/ico_bug.png differ
=== removed file 'loggerhead/static/images/ico_tag.gif'
Binary files loggerhead/static/images/ico_tag.gif and loggerhead/static/images/ico_tag.gif differ
=== removed file 'loggerhead/static/images/spinner.gif'
Binary files loggerhead/static/images/spinner.gif and loggerhead/static/images/spinner.gif differ
=== modified file 'loggerhead/static/javascript/changelog.js'
--- loggerhead/static/javascript/changelog.js	2009-03-31 21:11:38 +0000
+++ loggerhead/static/javascript/changelog.js	2009-02-20 03:30:31 +0000
@@ -53,23 +53,15 @@
     revlogs.each(
       function(item, i)
       {
-        var revid = revids[item.get('id').replace('log-', '')];
-        var collapsable = new Collapsable(
-          {
-            expand_icon: item.query('.expand_icon'),
-            open_node: item.query('.long_description'),
-            close_node: item.query('.short_description'),
-            source: global_path + '+revlog/' + revid,
-            loading: item.query('.loading'),
-            is_open: false
-          });
+        var item_slide = item.query('.revisioninfo');
+        var open_content  = new Array();
+        var close_content = new Array();
+        open_content.push(item.query('.long_description'));
+        close_content.push(item.query('.short_description'));
+        var expand_icon = item.query('.expand_icon');
+        var collapsable = new Collapsable(item_slide, expand_icon, open_content, close_content, false);
 
-        item.query('.expand_revisioninfo a').on(
-          'click',
-          function(e) {
-            e.preventDefault();
-            collapsable.toggle();
-          });
+        item.query('.expand_revisioninfo').on('click',function(){collapsable.toggle();});
         item.collapsable = collapsable;
       });
 

=== modified file 'loggerhead/static/javascript/custom.js'
--- loggerhead/static/javascript/custom.js	2009-04-01 15:28:21 +0000
+++ loggerhead/static/javascript/custom.js	2009-02-26 01:04:18 +0000
@@ -75,18 +75,30 @@
   setTimeout("Y.get('#search_terms').setStyle('display','none')", 300);
 }
 
-function Collapsable(config)
+function Collapsable(item, expand_icon, open_content, close_content, is_open)
 {
-  this.is_open = config.is_open;
-  this.open_node = config.open_node;
-  this.close_node = config.close_node;
-  this.expand_icon = config.expand_icon;
-  this.source = config.source;
-  this.loading = config.loading;
-  this.node_process = config.node_process;
-  this.container = null;
-  this.anim = null;
-  this._loading = false;
+  this.is_open = is_open;
+  this.item = item;
+  this.open_content  = open_content;
+  this.close_content = close_content;
+  this.expand_icon   = expand_icon;
+
+  if (this.is_open) {
+    this.height = item.get('region').height;
+  }
+  else {
+    this.height = null;
+  }
+
+  //var expander = new Fx.Slide(this.item, { duration: 200 } );
+  if (!this.is_open)
+  {
+    this.expand_icon.set('src',this.expand_icon.get('title'));
+  }
+  else
+  {
+    this.expand_icon.set('src',this.expand_icon.get('alt'));
+  }
 }
 
 function get_height(node) {
@@ -100,157 +112,56 @@
   return height;
 }
 
-Collapsable.prototype._animate = function (callback)
+Collapsable.prototype.open = function()
 {
-  if (this.anim) this.anim.stop();
+  if (this.height == null) {
+    this.height = get_height(this.item);
+  }
 
-  this.anim = new Y.Anim(
+  var anim = new Y.Anim(
     {
-      node: this.container,
+      node: this.item,
       from: {
-        marginBottom: this.container.getStyle('marginBottom')
+        height: 0
       },
       to: {
-        marginBottom: 0
+        height: this.height
       },
       duration: 0.2
     });
-
-  this.anim.run();
-  this.anim.on('end', this.animComplete, this, callback);
-}
-
-Collapsable.prototype._load_finished = function(tid, res, args)
-{
-  var l = res.responseText.split('\n');
-  l.splice(0, 1);
-  var newNode = Y.Node.create(l.join(''));
-  if (this.node_process)
-    this.node_process(newNode);
-  this.source = null;
-  newNode.setStyle('display', 'none');
-  this.loading.ancestor().insertBefore(newNode, this.loading);
-  var delta = this.loading.get('region').height - get_height(newNode);
-  newNode.setStyle('display', 'block');
-  this.container.setStyle('marginBottom', parseFloat(this.container.getStyle('marginBottom')) + delta);
-  this.loading.ancestor().removeChild(this.loading);
-  this._animate(args[0]);
-};
-
-Collapsable.prototype._ensure_container = function(callback)
-{
-  if (this.container == null) {
-    this.container = Y.Node.create('<div></div>');
-    if (this.closed_node) {
-      this.closed_node.ancestor().replaceChild(
-        this.container, this.closed_node);
-      this.container.appendChild(this.closed_node);
-      if (this.open_node) {
-        this.container.appendChild(this.open_node);
-      }
-    }
-    else {
-      this.open_node.ancestor().replaceChild(
-        this.container, this.open_node);
-      this.container.appendChild(this.open_node);
-    }
-    var outer = Y.Node.create('<div style="overflow:hidden;"></div>');
-    this.container.ancestor().replaceChild(outer, this.container);
-    outer.appendChild(this.container);
-  }
-}
-
-/* What happens when you click open.
- *
- * 1. The arrow flips to the expanded position.
- *
- * 2. If necessary, the div which will be running the animation is
- * created and the open/closed content stuffed into it (and has height
- * set to the height of the closed content).
- *
- * 3. The open content is shown and the closed content is closed.
- *
- * 4. The animation to expose all of the open content is started.
- *
- * 5. If we have to do ajax to load content, start the request.
- *
- * 6. When the request completes, parse the content into a node, run
- * the node_process callback over it and replace the spinner (assumed
- * to be appropriately contained in the open node) with the new node.
- *
- * 7. If the animation showing the open content has not completed,
- * stop it.
- *
- * 8. Start a new animation to show the rest of the new content.
- */
-
-Collapsable.prototype.open = function(callback)
-{
-  this.expand_icon.set('src', expanded_icon_path);
-
-  this._ensure_container();
-
-  var open_height = get_height(this.open_node);
-
-  var close_height;
-  if (this.close_node) {
-    close_height = this.close_node.get('region').height;
-  }
-  else {
-    close_height = 0;
-  }
-
-  this.container.setStyle('marginBottom', close_height - open_height);
-  if (this.close_node) {
-    this.close_node.setStyle('display', 'none');
-  }
-  this.open_node.setStyle('display', 'block');
-
-  this._animate(callback);
-
-  if (this.source) {
-    Y.io(
-      this.source,
-      {
-        on: {complete: this._load_finished},
-        arguments: [callback],
-        context: this
-      });
-    return;
-  }
-
-};
-
-Collapsable.prototype.animComplete = function(evt, callback)
-{
-  this.anim = null;
-  if (this._loading) return;
-  if (callback) callback();
+  anim.on('end', this.openComplete, this);
+  this.item.setStyle('height', 0);
+  this.item.setStyle('display', 'block');
+  anim.run();
+};
+
+Collapsable.prototype.openComplete = function()
+{
+  for (var i=0;i<this.open_content.length;++i)
+  {
+    this.open_content[i].setStyle('display','block');
+  }
+
+  for (var i=0;i<this.close_content.length;++i)
+  {
+    this.close_content[i].setStyle('display','none');
+  }
+
+  this.expand_icon.set('src',this.expand_icon.get('alt'));
   this.is_open = true;
 };
 
 Collapsable.prototype.close = function()
 {
-  this._ensure_container();
-
-  var open_height = this.open_node.get('region').height;
-
-  var close_height;
-  if (this.close_node) {
-    close_height = get_height(this.close_node);
-  }
-  else {
-    close_height = 0;
-  }
-
+  var item = this.item;
   var anim = new Y.Anim(
     {
-      node: this.container,
+      node: this.item,
       from: {
-        marginBottom: 0
+        height: this.height
       },
       to: {
-        marginBottom: close_height - open_height
+        height: 0
       },
       duration: 0.2
     });
@@ -259,18 +170,29 @@
 };
 
 Collapsable.prototype.closeComplete = function () {
-  this.open_node.setStyle('display', 'none');
-  if (this.close_node) {
-    this.close_node.setStyle('display', 'block');
-  }
-  this.container.setStyle('marginBottom', 0);
-  this.expand_icon.set('src', collapsed_icon_path);
+  this.item.setStyle('display', 'none');
+  var i;
+  for (i=0;i<this.open_content.length;++i)
+  {
+    this.open_content[i].setStyle('display','none');
+  }
+
+  for (i=0;i<this.close_content.length;++i)
+  {
+    this.close_content[i].setStyle('display','block');
+  }
+  this.expand_icon.set('src',this.expand_icon.get('title'));
   this.is_open = false;
 };
 
+Collapsable.prototype.isOpen = function()
+{
+  return this.is_open;
+};
+
 Collapsable.prototype.toggle = function()
 {
-  if (this.is_open)
+  if (this.isOpen())
   {
     this.close();
   }

=== modified file 'loggerhead/static/javascript/diff.js'
--- loggerhead/static/javascript/diff.js	2009-03-31 21:11:38 +0000
+++ loggerhead/static/javascript/diff.js	2009-02-26 02:06:31 +0000
@@ -41,6 +41,7 @@
   var removed = [];
   function clear_bufs(before) {
     if (!added.length && !removed.length) return;
+    Y.log('hai');
     var common = Math.min(added.length, removed.length);
     for (var i = 0; i < common; i++) {
       var a = added[i];
@@ -87,14 +88,13 @@
 
 function toggle_unified_sbs(event) {
   event.preventDefault();
-  var pts = Y.all(".pseudotable");
   if (unified) {
-    pts && pts.each(make_sbs);
+    Y.all(".pseudotable").each(make_sbs);
     unified = false;
     Y.get("#toggle_unified_sbs").set('innerHTML', "Show unified diffs");
   }
   else {
-    pts && pts.each(make_unified);
+    Y.all(".pseudotable").each(make_unified);
     unified = true;
     Y.get("#toggle_unified_sbs").set('innerHTML', "Show diffs side-by-side");
   }
@@ -104,7 +104,7 @@
 
 function toggle_expand_all_revisionview(action)
 {
-  var diffs = Y.all('.diff');
+  var diffs = Y.all('.diffBox');
   if (diffs == null) return;
   diffs.each(
     function(item, i)
@@ -143,62 +143,18 @@
   '#collapse_all a'
 );
 
-function node_process(node) {
-  if (!unified) {
-    node.get('children').filter('.pseudotable').each(make_sbs);
-  }
-}
-
-function zoom_to_diff (path) {
-  var collapsable = Y.get('#' + path_to_id[path]).collapsable;
-  if (!collapsable.is_open) {
-    collapsable.open(
-      function () {
-        window.location.hash = '#' + path;
-      });
-  }
-}
-
 Y.on(
   "domready", function () {
     Y.all(".show_if_js").removeClass("show_if_js");
-    if (!specific_path) {
-      Y.all("#list-files a").on(
-        'click',
-        function (e) {
-          e.preventDefault();
-          var path = decodeURIComponent(e.target.get('href').split('#')[1]);
-          window.location.hash = '#' + path;
-          zoom_to_diff(path);
-        });
-    }
-    var diffs = Y.all('.diff');
+    var diffs = Y.all('.diffBox');
     if (diffs == null) return;
     diffs.each(
       function(item, i)
       {
-        var source_url = null;
-        if (!specific_path)
-          source_url = global_path + '+filediff/' + link_data[item.get('id')];
-        item.query('.the-link').on(
-          'click',
-          function(e) {
-            e.preventDefault();
-            collapsable.toggle();
-          });
-        var collapsable = new Collapsable(
-          {
-            expand_icon: item.query('.expand_diff'),
-            open_node: item.query('.diffinfo'),
-            close_node: null,
-            source: source_url,
-            is_open: specific_path != null,
-            loading: item.query('.loading'),
-            node_process: node_process
-          });
-       item.collapsable=collapsable;
-       });
-    if (window.location.hash && !specific_path) {
-      zoom_to_diff(window.location.hash.substring(1));
-    }
+        var item_slide = item.next('.diffinfo');
+        var expand_icon = item.query( '.expand_diff' );
+        var collapsable = new Collapsable(item_slide, expand_icon, [], [], true);
+        item.query('.expand_diff').on('click', function(){collapsable.toggle();});
+        item.collapsable=collapsable;
+      });
   });

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2009-10-17 08:47:38 +0000
+++ loggerhead/templatefunctions.py	2009-02-18 10:36:48 +0000
@@ -13,15 +13,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-
-import cgi
 import os
-
-import pkg_resources
-
-import bzrlib
-
-import loggerhead
 from loggerhead.zptsupport import zpt
 
 
@@ -45,31 +37,19 @@
 
 
 @templatefunc
-def file_change_summary(url, entry, file_changes, style='normal', currently_showing=None):
-    if style == 'fragment':
-        def file_link(filename):
-            if currently_showing and filename == currently_showing:
-                return '<b><a href="#%s">%s</a></b>' % (
-                    cgi.escape(filename), cgi.escape(filename))
-            else:
-                return revision_link(
-                    url, entry.revno, filename, '#' + filename)
-    else:
-        def file_link(filename):
-            return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
-                url(['/revision', entry.revno]), '#' + filename, cgi.escape(filename),
-                cgi.escape(entry.revno), cgi.escape(filename))
+def file_change_summary(url, entry, modified_file_link):
     return _pt('revisionfilechanges').expand(
-        entry=entry, file_changes=file_changes, file_link=file_link, **templatefunctions)
+        url=url, entry=entry, modified_file_link=modified_file_link,
+        **templatefunctions)
 
 
 @templatefunc
-def revisioninfo(url, branch, entry, file_changes=None, currently_showing=None, merged_in=None):
+def revisioninfo(url, branch, entry, modified_file_link=None):
     from loggerhead import util
     return _pt('revisioninfo').expand(
         url=url, change=entry, branch=branch, util=util,
-        file_changes=file_changes, currently_showing=currently_showing,
-        merged_in=merged_in, **templatefunctions)
+        modified_file_link=modified_file_link,
+        **templatefunctions)
 
 
 @templatefunc
@@ -100,7 +80,21 @@
         extra = ' ' + entry.branch_nick
     else:
         extra = ''
-    return '(%s%s)' % (entry.revno, extra)
+    return '(%s%s)'%(entry.revno, extra)
+
+
+@templatefunc
+def modified_file_link_rev(url, entry, item):
+    return _pt('modified-file-link-rev').expand(
+        url=url, entry=entry, item=item,
+        **templatefunctions)
+
+
+@templatefunc
+def modified_file_link_log(url, entry, item):
+    return _pt('modified-file-link-log').expand(
+        url=url, entry=entry, item=item,
+        **templatefunctions)
 
 
 @templatefunc
@@ -118,88 +112,3 @@
 def menu(branch, url, fileview_active=False):
     return _pt('menu').expand(branch=branch, url=url,
         fileview_active=fileview_active, **templatefunctions)
-
-
-@templatefunc
-def annotate_link(url, revno, path):
-    return '<a href="%s" title="Annotate %s">%s</a>' % (
-        url(['/annotate', revno, path]), cgi.escape(path), cgi.escape(path))
-
-@templatefunc
-def revision_link(url, revno, path, frag=''):
-    return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
-        url(['/revision', revno, path]), frag, cgi.escape(path),
-        cgi.escape(revno), cgi.escape(path))
-
-
-@templatefunc
-def loggerhead_version():
-    return loggerhead.__version__
-
-_cached_generator_string = None
-
-@templatefunc
-def generator_string():
-    global _cached_generator_string
-    if _cached_generator_string is None:
-        versions = []
-
-        # TODO: Errors -- e.g. from a missing/invalid __version__ attribute, or
-        # ValueError accessing Distribution.version -- should be non-fatal.
-
-        versions.append(('Loggerhead', loggerhead.__version__))
-
-        import sys
-        python_version = bzrlib._format_version_tuple(sys.version_info)
-        versions.append(('Python', python_version))
-
-        versions.append(('Bazaar', bzrlib.__version__))
-
-        Paste = pkg_resources.get_distribution('Paste')
-        versions.append(('Paste', Paste.version))
-
-        try:
-            PasteDeploy = pkg_resources.get_distribution('PasteDeploy')
-        except pkg_resources.DistributionNotFound:
-            pass
-        else:
-            versions.append(('PasteDeploy', PasteDeploy.version))
-
-        import simpletal
-        versions.append(('SimpleTAL', simpletal.__version__))
-
-        try:
-            import pygments
-        except ImportError:
-            pass
-        else:
-            versions.append(('Pygments', pygments.__version__))
-
-        try:
-            from bzrlib.plugins import search
-        except ImportError:
-            pass
-        else:
-            bzr_search_version = bzrlib._format_version_tuple(
-                search.version_info)
-            versions.append(('bzr-search', bzr_search_version))
-
-        # TODO: On old Python versions, elementtree may be used.
-
-        try:
-            import simplejson
-        except ImportError:
-            pass
-        else:
-            versions.append(('simplejson', simplejson.__version__))
-
-        try:
-            Dozer = pkg_resources.get_distribution('Dozer')
-        except pkg_resources.DistributionNotFound:
-            pass
-        else:
-            versions.append(('Dozer', Dozer.version))
-
-        version_strings = ("%s/%s" % t for t in versions)
-        _cached_generator_string = ' '.join(version_strings)
-    return _cached_generator_string

=== modified file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	2009-03-06 09:57:54 +0000
+++ loggerhead/templates/annotate.pt	2009-03-02 00:10:26 +0000
@@ -65,7 +65,7 @@
               <a tal:condition="python:line.status=='changed'"
                  tal:content="python:util.trunc(line.change.revno)"
                  tal:attributes="href python:url(['/revision', line.change.revno], clear=1);
-                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, ', '.join(util.hide_emails(line.change.authors)), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))"></a>
+                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, util.hide_email(line.change.author), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))"></a>
             </td>
             <td class="annoCont"><pre tal:content="structure line/text"></pre></td>
           </tr>

=== modified file 'loggerhead/templates/atom.pt'
--- loggerhead/templates/atom.pt	2009-06-06 12:23:11 +0000
+++ loggerhead/templates/atom.pt	2008-06-26 20:42:15 +0000
@@ -3,31 +3,29 @@
   <title>
     bazaar changes for <tal:branch-name content="branch/friendly_name">branch name</tal:branch-name>
   </title>
-  <updated tal:content="string:${updated}Z">${updated}</updated>
+  <updated tal:content="updated">${updated}</updated>
   <id tal:content="python:branch.url(['/atom'])">url</id>
-  <link rel="self" type="application/atom+xml" tal:attributes="href python:branch.url(['/atom'])" />
-  <link rel="alternate" type="text/html" tal:attributes="href python:branch.url(['/changes'])" />
+  <link rel="self" tal:attributes="href python:branch.url([''])" />
 
   <entry tal:repeat="entry changes">
-    <title tal:content="string:${entry/revno}: ${entry/short_comment}">
+    <title tal:content="string: ${entry/revno}: ${entry/short_comment}">
       ${entry/revno}: ${entry/short_comment}
     </title>
-    <updated tal:content="string:${entry/utc_date/isoformat}Z">
-      updated
+    <updated tal:content="entry/date/isoformat">
+    Z
     </updated>
-    <!-- TODO: The feed validator will generate warnings because this is URL-encoded -->
     <id tal:content="python:branch.url(['/revision', entry.revno])">
       ID
     </id>
-    <author tal:repeat="author entry/authors">
-      <name tal:content="python:util.hide_email(author)">
+    <author>
+      <name tal:content="python:util.hide_email(entry.author)">
         author
       </name>
     </author>
     <content type="text" tal:content="entry/comment">
       comment
     </content>
-    <link rel="alternate" type="text/html"
+    <link rel="alternate"
           tal:attributes="href python:branch.url(['/revision', entry.revno])" />
   </entry>
 </feed>

=== modified file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	2009-05-13 13:14:04 +0000
+++ loggerhead/templates/browse.pt	2008-10-18 00:23:09 +0000
@@ -43,12 +43,12 @@
                   </a>
                 </td>
               </tr>
-              <tr tal:condition="view/served_url">
+              <tr tal:condition="view/branch_url">
                 <td class="name">
                 </td>
                 <td class="description url" colspan="2">
-                  <a tal:attributes="href view/served_url"
-                     tal:content="view/served_url" />
+                  <a tal:attributes="href view/branch_url"
+                     tal:content="view/branch_url" />
                 </td>
               </tr>
             </tal:block>

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2009-06-25 03:35:43 +0000
+++ loggerhead/templates/changelog.pt	2009-02-26 21:01:19 +0000
@@ -7,9 +7,6 @@
       <link rel="alternate" type="application/atom+xml"
             tal:attributes="href python:url(['/atom']);
                             title string:RSS feed for ${branch/friendly_name}" />
-    <script type="text/javascript">
-      var revids = <tal:block content="data" />;
-    </script>
       <script type="text/javascript"
               tal:attributes="src python:branch.static_url('/static/javascript/changelog.js')"></script>
     </metal:block>
@@ -51,10 +48,10 @@
       </p>
 
       <p class="fr revnolink">From Revision <a tal:attributes="href #
-                                                               title python:'Show revision '+history.get_revno(revid)"
+                                                               title python:'Show revision '+history.get_revno(revid)" 
                                                tal:content="python:history.get_revno(revid)"></a>
         <tal:block tal:condition="python:navigation.last_in_page_revid is not None"> to
-          <a tal:attributes="href #
+          <a tal:attributes="href # 
                              title 'Show revision '+history.get_revno(navigation.last_in_page_revid)"
              tal:content="python:history.get_revno(navigation.last_in_page_revid)"></a>
       </tal:block></p>
@@ -66,54 +63,72 @@
           <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
                alt="collapse all" /> collapse all</a>
       </p>
-      <!-- Table -->
+      <!-- Table -->        
       <table id="logentries">
         <tr class="logheader">
           <td class="revisionnumber">Rev</td>
-          <td class="expandcell show_if_js">&nbsp;</td>
+          <td class="expandcell">&nbsp;</td>
           <td class="summarycell">Summary</td>
-          <td class="authorcell">Authors</td>
-          <td tal:condition="show_tag_col" class="tagscell">Tags</td>
+          <td class="authorcell">Author</td>
           <td class="datecell">Date</td>
           <td class="diffcell">Diff</td>
           <td class="downloadcell">Files</td>
         </tr>
         <tal:block tal:repeat="entry changes">
           <a tal:attributes="name string:entry-${entry/revno}"/>
-          <tr tal:attributes="class string:blueRow${entry/parity} revision_log; id string:log-${entry/index}">
+          <tr tal:attributes="class string:blueRow${entry/parity} revision_log">
             <td class="revnro revnolink"><a tal:attributes="title python:'Show revision '+entry.revno;
                                                             href  python:url(['/revision', entry.revno], clear=1)"
                                             tal:content="python:util.trunc(entry.revno)"></a>
-            </td>
-            <td class="expcell show_if_js">
+            </td>            
+            <td class="expcell">
               <div class="expand_revisioninfo">
-                <a href="#">
-                  <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
-                       class="expand_icon" />
-                </a>
+                <!-- So, this is interesting. I'm using "alt" to have the correct URL for the image of the expanded icon
+                     and "title" tag for the contracted URL of the image. This is a bit of a hack, but it's better than
+                     other approaches I tried  :)  -->
+                <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png');
+                                     alt python:branch.static_url('/static/images/treeExpanded.png');
+                                     title python:branch.static_url('/static/images/treeCollapsed.png')" 
+                     class="expand_icon" />
               </div>
             </td>
-            <td class="summcell">
-              <div class="short_description">
+            <td class="summcell"><div tal:attributes="class string:short_description">
                 <a tal:attributes="title python:'Show revision '+entry.revno;
                                    href  python:url(['/revision', entry.revno], clear=1);
                                    class string:link"
                    tal:content="entry/short_comment"></a>
               </div>
-              <div class="long_description" style="display: none">
+              <div tal:attributes="class string:long_description;
+                                   style string:display:none">
                 <a tal:attributes="title python:'Show revision '+entry.revno;
                                    href  python:url(['/revision', entry.revno], clear=1);
                                    class string:link"
-                   tal:content="structure python:util.fixed_width(entry.comment)"></a>
-                <div class="loading">
-                  <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
-                </div>
+                   tal:content="entry/comment"></a>
+              </div>
+              <div class="revisioninfo" style="display:none;">
+                <ul class="expandrev">
+               	  <li class="mfrom" tal:repeat="parent python:entry.parents[1:]">
+                    <span class="revnolink">
+                      <a tal:attributes="href python:url(['/changes', parent.revno])"
+                         tal:content="parent/revno"></a>
+                    </span>
+                    <a tal:condition="parent.branch_nick"
+                       tal:attributes="href python:url(['/changes'], start_revid=parent.revno)"
+                       tal:content="python:'(' + parent.branch_nick + ')'"
+                       title="Show history" class="link"></a>
+                  </li>
+               	  <li class="mto" tal:repeat="merge_point entry/merge_points">
+                    <a tal:attributes="href python:url(['/changes'], start_revid=merge_point.revno)"
+                       tal:content="python:revno_with_nick(merge_point)"
+                       title="Show history" class="link"></a>
+                  </li>
+                  <li class="committerli" tal:content="python:util.hide_email(entry.author)"></li>
+                  <tal:block content="structure python:file_change_summary(url, entry, modified_file_link_log)" />
+                </ul>
               </div>
             </td>
-            <td tal:content="python:util.trunc(util.hide_email(entry.authors[0]), 20)"
+            <td tal:content="python:util.trunc(util.hide_email(entry.author), 20)"
                 class="autcell"></td>
-            <td tal:condition="show_tag_col" tal:content="string:${entry/tags}"
-                class="tagcell"></td>
             <td class="date">
               <span tal:attributes="title python:util.date_time(entry.date)"
                     tal:content="python:util._approximatedate(entry.date)"></span>
@@ -131,7 +146,7 @@
 
       <ul tal:condition="python:navigation.prev_page_revid or navigation.next_page_revid"
           id="pages">
-        <li tal:condition="navigation/prev_page_revid"
+        <li tal:condition="navigation/prev_page_revid" 
             class="previous">
           <a tal:attributes="href navigation/prev_page_url">&laquo; Newer</a>
         </li>

=== removed file 'loggerhead/templates/filediff.pt'
--- loggerhead/templates/filediff.pt	2009-04-01 15:28:21 +0000
+++ loggerhead/templates/filediff.pt	1970-01-01 00:00:00 +0000
@@ -1,25 +0,0 @@
-<div>
-  <div class="pseudotable unified"
-       tal:repeat="chunk chunks">
-
-    <tal:block condition="not:repeat/chunk/start">
-      <div class="pseudorow context-row">
-        <div class="lineNumber separate"></div>
-        <div class="lineNumber second separate"></div>
-        <div class="code separate"></div>
-        <div class="clear"><!-- --></div>
-      </div>
-    </tal:block>
-
-    <div tal:repeat="line chunk/diff"
-         tal:attributes="class string:pseudorow ${line/type}-row">
-      <div class="lineNumber first"
-           tal:content="structure python:util.fill_div(line.old_lineno)"></div>
-      <div class="lineNumber second"
-           tal:content="structure python:util.fill_div(line.new_lineno)"></div>
-      <div tal:attributes="class string:code ${line/type}"
-           tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
-      <div class="clear"><!-- --></div>
-    </div>
-  </div>
-</div>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2009-07-15 22:02:09 +0000
+++ loggerhead/templates/inventory.pt	2009-02-10 04:25:11 +0000
@@ -90,7 +90,7 @@
             <!-- Show this if it's a symlink -->
             <tr tal:attributes="class string:blueRow${repeat/file/even}" tal:condition="python:file.kind=='symlink'">
                 <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno, file.absolutepath])">
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_flecha.gif')" alt="Symlink" />
+                        <img tal:attributes="src python:branch.static_url('/static/images/ico_flecha.gif')" alt="Symlink" />
                     </a>
 
                  <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])" 

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2009-06-24 02:35:46 +0000
+++ loggerhead/templates/macros.pt	2009-03-02 05:09:06 +0000
@@ -3,8 +3,6 @@
 <html xmlns="http://www.w3.org/1999/xhtml" metal:define-macro="main">
   <head>
     <meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
-    <meta name="generator"
-          tal:attributes="content generator_string" />
 
     <title metal:define-slot="title"></title>
     <link rel="stylesheet"
@@ -15,27 +13,34 @@
     </tal:comment>
     <script type="text/javascript">
       var global_path = <tal:block content="python:'\''+branch.url('/')+'\''" />;
-      var collapsed_icon_path = <tal:block content="python:'\''+branch.static_url('/static/images/treeCollapsed.png')+'\''" />;
-      var expanded_icon_path = <tal:block content="python:'\''+branch.static_url('/static/images/treeExpanded.png')+'\''" />;
     </script>
     <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('yui/yui-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('oop/oop-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('event/event-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('attribute/attribute-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('base/base-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('dom/dom-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('node/node-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('anim/anim-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('io/io-base-min.js')"></script>
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/yui/yui-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/oop/oop-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/event/event-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/attribute/attribute-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/base/base-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/dom/dom-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/node/node-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/anim/anim-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/io/io-base-min.js')"></script>
     <script type="text/javascript"
             tal:attributes="src python:branch.static_url('/static/javascript/custom.js')"></script>
     <metal:block metal:define-slot="header_extras" />
@@ -61,7 +66,7 @@
         <h1 metal:define-slot="heading"></h1>
         <div metal:define-slot="content"></div>
 
-        <p class="fl">Loggerhead <tal:version content="loggerhead_version" /> is a web-based interface for <a href="http://bazaar-vcs.org/">Bazaar</a> branches</p>
+        <p class="fl">Loggerhead is a web-based interface for <a href="http://bazaar-vcs.org/">Bazaar</a> branches</p>
       </div>
   </body>
 </html>

=== added file 'loggerhead/templates/modified-file-link-rev.pt'
--- loggerhead/templates/modified-file-link-rev.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/modified-file-link-rev.pt	2008-06-19 21:39:15 +0000
@@ -0,0 +1,7 @@
+<tal:block>
+<li class="files"><a 
+     tal:attributes="href  string:#${item/filename}-s;
+                     title string:Jump to ${item/filename} below"
+     tal:content="item/filename" >
+</a></li>
+</tal:block>

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2009-04-28 03:01:54 +0000
+++ loggerhead/templates/revision.pt	2009-02-26 21:01:19 +0000
@@ -11,11 +11,6 @@
               tal:attributes="href python:branch.static_url('/static/css/diff.css')"/>
         <script type="text/javascript"
                 tal:attributes="src python:branch.static_url('/static/javascript/diff.js')"></script>
-        <script type="text/javascript">
-          var link_data = <tal:b content="link_data" />;
-          var specific_path = <tal:b content="json_specific_path" />;
-          var path_to_id = <tal:b content="path_to_id" />;
-        </script>
       </metal:block>
     </head>
 
@@ -32,31 +27,12 @@
           <tal:no-link condition="not: branch/branch_link">
             <span metal:use-macro="breadcrumbs/directory"></span>
           </tal:no-link>
-          <span class="breadcrumb">:
-            <tal:revno condition="not:specific_path" content="change/revno"></tal:revno>
-            <a tal:condition="specific_path" tal:content="change/revno"
-               tal:attributes="href python:url(['/revision', change.revno])"
-               title="View changes to all files"></a>
-                      <tal:compare-to condition="python:compare_revid is not None">
+          <span>: <tal:revno content="change/revno"></tal:revno>
+            <tal:compare-to condition="python:compare_revid is not None">
               (compared to revision <tal:block content="python:history.get_revno(compare_revid)" />)
             </tal:compare-to>
-          </span>
-          <span class="breadcrumb" tal:condition="specific_path">
-            : <tal:annotate content="structure python:annotate_link(url, change.revno, specific_path)" />
-          </span>
-        </h1>
+        </span></h1>
         <tal:branch-info replace="structure python:branchinfo(branch)" />
-        <p tal:condition="not:specific_path">
-          Viewing all changes in revision <tal:revno content="change/revno" />.
-        </p>
-        <p tal:condition="specific_path">
-          <a tal:attributes="href python:url(['/revision', change.revno])">
-            &#xAB; back to all changes in this revision
-          </a>
-        </p>
-        <p tal:condition="specific_path">
-          Viewing changes to <tal:annotate content="structure python:annotate_link(url, change.revno, specific_path)" />
-        </p>
         <ul id="submenuTabs">
           <li id="first"><a tal:attributes="href python:url(['/files', change.revno]);
                                             title string:browse files at revision ${change/revno}"
@@ -96,17 +72,15 @@
           </ul>
         </tal:we-are-comparing>
 
-        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, file_changes, specific_path, merged_in)" />
-        <tal:specific-path condition="not:specific_path">
-          <p class="expand show_if_js" id="expand_all"><a href="#">
-              <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
-                   alt="expand all" /> expand all</a>
-          </p>
-          <p class="expand" id="collapse_all" style="display:none;"><a href="#">
-              <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
-                   alt="collapse all" /> collapse all</a>
-          </p>
-        </tal:specific-path>
+        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, modified_file_link_rev)" />
+        <p class="expand" id="expand_all" style="display:none;"><a href="#">
+            <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
+                 alt="expand all" /> expand all</a>
+        </p>
+        <p class="expand show_if_js" id="collapse_all"><a href="#">
+            <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
+                 alt="collapse all" /> collapse all</a>
+        </p>
         <!-- Table -->
         <p class="expand show_if_js"><a id="toggle_unified_sbs" href="#">Show diffs side-by-side</a></p>
         <p class="codin"><img tal:attributes="src python:branch.static_url('/static/images/newCode.gif')" alt="added" /> added</p>
@@ -116,75 +90,46 @@
       </tal:block>
 
       <div metal:fill-slot="content">
-        <tal:block condition="specific_path">
-          <div class="diff">
-
-            <div  class="diffBox">
-              <a tal:attributes="href python:url(['/revision', change.revno, specific_path], clear=1);
-                                 id string:${specific_path};
-                                 title string:View changes to ${specific_path} only"
-                 class="the-link">
-                <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
-                     class="expand_diff"/>
-                <tal:b content="specific_path" />
-              </a>
-            </div>
-            <div style="overflow: hidden">
-              <div class="container">
-                <div class="loading" style="display:none">
-                  <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
-                </div>
-                <div class="diffinfo">
-                  <div class="pseudotable unified"
-                       tal:repeat="chunk diff_chunks">
-
-                    <tal:block condition="not:repeat/chunk/start">
-                      <div class="pseudorow context-row">
-                        <div class="lineNumber separate"></div>
-                        <div class="lineNumber second separate"></div>
-                        <div class="code separate"></div>
-                        <div class="clear"><!-- --></div>
-                      </div>
-                    </tal:block>
-
-                    <div tal:repeat="line chunk/diff"
-                         tal:attributes="class string:pseudorow ${line/type}-row">
-                      <div class="lineNumber first"
-                           tal:content="structure python:util.fill_div(line.old_lineno)"></div>
-                      <div class="lineNumber second"
-                           tal:content="structure python:util.fill_div(line.new_lineno)"></div>
-                      <div tal:attributes="class string:code ${line/type}"
-                           tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
-                      <div class="clear"><!-- --></div>
-                    </div>
-                  </div>
-                </div>
-              </div>
-            </div>
-          </div>
-        </tal:block>
-
-        <tal:block condition="not:specific_path">
-          <div class="diff"
-               tal:repeat="item file_changes/text_changes" tal:attributes="id string:diff-${item/index}">
-
-            <div  class="diffBox">
-              <a tal:attributes="href python:url(['/revision', change.revno, item.filename], clear=1);
-                                 id string:${item/filename};
-                                 title string:View changes to ${item/filename} only"
-                 class="the-link">
-                <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
-                     class="expand_diff" />
-                <tal:b content="item/filename" />
-              </a>
-            </div>
-            <div class="diffinfo"  style="display:none">
-              <div class="loading">
-                <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
-              </div>
-            </div>
-          </div>
-        </tal:block>
+        <div class="diff"
+             tal:repeat="item change/changes/modified">
+
+          <div class="diffBox">
+            <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png');
+                                 title python:branch.static_url('/static/images/treeCollapsed.png');
+                                 alt python:branch.static_url('/static/images/treeExpanded.png')"
+                 class="expand_diff" />
+            <a tal:attributes="href python:url(['/annotate', change.revno], clear=1, file_id=item.file_id);
+                               id string:${item/filename}-s;
+                               title string:Annotate ${item/filename}"
+               tal:content="item/filename">
+            </a>
+          </div>
+          <div class="diffinfo">
+            <div class="pseudotable unified"
+                 tal:repeat="chunk item/chunks">
+
+              <tal:block condition="not:repeat/chunk/start">
+                <div class="pseudorow context">
+                  <div class="lineNumber separate"></div>
+                  <div class="lineNumber second separate"></div>
+                  <div class="code separate"></div>
+                  <div class="clear"><!-- --></div>
+                </div>
+              </tal:block>
+
+              <div tal:repeat="line chunk/diff"
+                   tal:attributes="class string:pseudorow ${line/type}-row">
+                <div class="lineNumber first"
+                     tal:content="structure python:util.fill_div(line.old_lineno)"></div>
+                <div class="lineNumber second"
+                     tal:content="structure python:util.fill_div(line.new_lineno)"></div>
+                <div tal:attributes="class string:code ${line/type}"
+                     tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
+                <div class="clear"><!-- --></div>
+              </div>
+            </div>
+          </div>
+        </div>
 
         <ul tal:condition="python:navigation.prev_page_revid or navigation.next_page_revid"
             id="pages">

=== modified file 'loggerhead/templates/revisionfilechanges.pt'
--- loggerhead/templates/revisionfilechanges.pt	2009-03-19 00:05:41 +0000
+++ loggerhead/templates/revisionfilechanges.pt	2008-07-23 21:31:07 +0000
@@ -1,50 +1,58 @@
 <tal:block>
-  <ul tal:repeat="added file_changes/added">
+<ul tal:repeat="added entry/changes/added">
     <tal:block condition="repeat/added/start">
-      <li class="desc">files added:</li>
+        <li class="desc">files added:</li>
     </tal:block>
-    <li class="files">
-      <tal:revision condition="python:added.kind == 'file'"
-                    content="structure python:file_link(added.filename)" />
-      <tal:revision condition="python:added.kind != 'file'"
-                    content="added/filename" />
+    <li class="files"
+        tal:define="filename python:added[0];
+                    file_id  python:added[1]">
+        <a tal:attributes="href  python:url(['/annotate', entry.revno], file_id=file_id);
+                           title string:Annotate ${filename}"
+           tal:content="filename" class="link"></a>
     </li>
-  </ul>
+</ul>
 
-  <ul tal:repeat="removed file_changes/removed">
+<ul tal:repeat="removed entry/changes/removed">
     <tal:block condition="repeat/removed/start">
-      <li class="desc">files removed:</li>
+        <li class="desc">files removed:</li>
     </tal:block>
-    <li class="files">
-      <tal:revision condition="python:removed.kind == 'file'"
-                    content="structure python:file_link(removed.filename)" />
-      <tal:revision condition="python:removed.kind != 'file'"
-                    content="removed/filename" />
+    <li class="files"
+        tal:define="filename python:removed[0];
+                    file_id  python:removed[1]">
+      <tal:block content="filename" />
     </li>
-  </ul>
+</ul>
 
-  <ul tal:repeat="renamed file_changes/renamed">
+<ul tal:repeat="renamed entry/changes/renamed">
     <tal:block condition="repeat/renamed/start">
-      <li class="desc">files renamed:</li>
+        <li class="desc">files renamed:</li>
     </tal:block>
-    <li class="files">
-      <tal:old-name content="renamed/old_filename" class="filename">
+    <li class="files"
+        tal:define="old_filename python:renamed[0];
+                    new_filename python:renamed[1];
+                    file_id      python:renamed[2]">
+      <a tal:attributes="href  python:url(['/annotate', entry.revno], file_id=file_id);
+                         title string:Annotate ${old_filename}"
+         tal:content="old_filename" class="filename">
         old_filename
-      </tal:old-name>
-      =&gt;
-      <tal:revision condition="renamed/text_modified" content="structure python:file_link(renamed.new_filename)" />
-      <tal:old-name condition="not:renamed/text_modified" content="renamed/new_filename" class="filename">
+      </a>
+      =>
+      <a tal:attributes="href  python:url(['/annotate', entry.revno], file_id=file_id);
+                         title string:Annotate ${new_filename}"
+         tal:content="new_filename">
         new_filename
-      </tal:old-name>
+      </a>
     </li>
-  </ul>
+</ul>
 
-  <ul tal:repeat="item file_changes/modified">
+<ul tal:repeat="item entry/changes/modified">
     <tal:block condition="repeat/item/start">
-      <li class="desc">files modified:</li>
+        <li class="desc">files modified:</li>
     </tal:block>
     <li class="files">
-      <tal:revision content="structure python:file_link(item.filename)" />
+      <a tal:attributes="href  python:url(['/annotate', entry.revno], file_id=item.file_id);
+                         title string:Annotate ${item/filename}"
+                         tal:content="item/filename"/>
     </li>
-  </ul>
+</ul>
 </tal:block>

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2009-06-11 21:16:27 +0000
+++ loggerhead/templates/revisioninfo.pt	2009-01-23 19:19:39 +0000
@@ -1,6 +1,6 @@
 <div class="infoContainer">
     <div id="infTxt">
-        <div class="committer" tal:content="python:', '.join(util.hide_emails(change.authors))"></div>
+        <div class="committer" tal:content="python:util.hide_email(change.author)"></div>
         <div class="timer" tal:content="python:util.date_time(change.date)"></div>
         <div class="mfrom" tal:repeat="parent python:change.parents[1:]">
             <a tal:attributes="title string:Merged From ${parent/revno};
@@ -12,21 +12,12 @@
                                href python:url(['/revision', merge_point.revno], clear=1)"
                tal:content="python:revno_with_nick(merge_point)"></a>
         </div>
-        <div class="mto" tal:condition="merged_in">
-          This revision was merged to the branch mainline in
-          <a tal:attributes="href python:url(['/revision', merged_in], clear=1)">revision
-            <tal:b content="merged_in"/></a>.
-        </div>
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
-        <div class="tags" tal:condition="change/tags" tal:content="string:Tags: ${change/tags}"></div>
-        <div class="clear"><!-- --></div>
-        <div class="bug" tal:repeat="bug change/bugs">
-            <a tal:attributes="href bug" tal:content="bug"></a>
-        </div>
-        <div class="information" tal:content="structure python:util.fixed_width(change.comment)"></div>
+        <div class="information" tal:content="python:util.fixed_width(change.comment)"></div>
     </div>
-    <ul id="list-files" tal:condition="file_changes">
-      <tal:block content="structure python:file_change_summary(url, change, file_changes, 'fragment', currently_showing)" />
+    <ul id="list-files">
+        <tal:block condition="nocall:modified_file_link">
+        <tal:block content="structure python:file_change_summary(url, change, modified_file_link)" /></tal:block>
     </ul>
     <div class="clear"><!-- --></div>
 </div>

=== removed file 'loggerhead/templates/revlog.pt'
--- loggerhead/templates/revlog.pt	2009-03-31 15:23:54 +0000
+++ loggerhead/templates/revlog.pt	1970-01-01 00:00:00 +0000
@@ -1,17 +0,0 @@
-<div class="revisioninfo">
-  <ul class="expandrev">
-    <li class="mfrom" tal:repeat="parent python:entry.parents[1:]">
-      <span class="revnolink">
-        <a tal:attributes="href python:url(['/changes', parent.revno])"
-           tal:content="python:revno_with_nick(parent)"></a>
-      </span>
-    </li>
-    <li class="mto" tal:repeat="merge_point entry/merge_points">
-      <a tal:attributes="href python:url(['/changes', merge_point.revno])"
-         tal:content="python:revno_with_nick(merge_point)"
-         title="Show history" class="link"></a>
-    </li>
-    <li class="committerli" tal:content="python:', '.join(util.hide_emails(entry.authors))"></li>
-    <tal:block content="structure python:file_change_summary(url, entry, file_changes)" />
-  </ul>
-</div>

=== modified file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2009-03-19 18:48:15 +0000
+++ loggerhead/tests/test_controllers.py	2009-02-23 20:32:43 +0000
@@ -32,8 +32,8 @@
         self.build_tree_contents(shape1)
         tree.smart_add([])
         tree.commit('')
+        tree.smart_add([])
         self.build_tree_contents(shape2)
-        tree.smart_add([])
         tree.commit('')
         tree.branch.lock_read()
         self.addCleanup(tree.branch.unlock)
@@ -53,10 +53,9 @@
         rev_ui.args = ['2']
         util.set_context({})
         self.assertIsInstance(
-            rev_ui.get_values('', {}, []),
+            rev_ui.get_values('2', {}, []),
             dict)
 
-
 class TestAnnotateUI(BasicTests):
 
     def make_annotate_ui_for_file_history(self, file_id, rev_ids_texts):

=== modified file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	2009-04-02 20:32:12 +0000
+++ loggerhead/tests/test_corners.py	2009-02-10 01:58:31 +0000
@@ -34,16 +34,6 @@
         res = app.get('/revision/'+newrevid)
         res.mustcontain('executable')
 
-    def test_revision_escapes_commit_message(self):
-        """XXX."""
-        self.createBranch()
-
-        msg = '<b>hi</b>'
-        self.addFileAndCommit('myfilename', msg)
-        app = self.setUpLoggerhead()
-        res = app.get('/revision/1')
-        self.assertFalse(msg in res.body)
-
     def test_empty_commit_message(self):
         """Check that an empty commit message does not break the rendering."""
         self.createBranch()
@@ -56,7 +46,7 @@
         res = app.get('/changes')
         # It's not much of an assertion, but we only really care about
         # "assert not crashed".
-        res.mustcontain('1')
+        res.mustcontain('myfilename')
 
     def test_whitespace_only_commit_message(self):
         """Check that a whitespace-only commit message does not break the
@@ -71,4 +61,4 @@
         res = app.get('/changes')
         # It's not much of an assertion, but we only really care about
         # "assert not crashed".
-        res.mustcontain('1')
+        res.mustcontain('myfilename')

=== added file 'loggerhead/tests/test_filechangecache.py'
--- loggerhead/tests/test_filechangecache.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_filechangecache.py	2008-10-24 02:26:05 +0000
@@ -0,0 +1,98 @@
+"""Tests for the FileChangeCache in loggerhead.changecache."""
+
+import shutil
+import tempfile
+
+from loggerhead.changecache import FileChangeCache
+
+
+class MockEntry(object):
+
+    def __init__(self, revid):
+        self.revid = revid
+
+
+class MockHistory(object):
+
+    def __init__(self):
+        self.fetched_revids = set()
+
+    def get_file_changes_uncached(self, entries):
+        output = []
+        for entry in entries:
+            self.fetched_revids.add(entry.revid)
+            output.append(entry.revid)
+        return output
+
+
+class TestFileChangeCache(object):
+
+    # setup_method and teardown_method are so i can run the tests with
+    # py.test and take advantage of the error reporting.
+
+    def setup_method(self, meth):
+        self.setUp()
+
+    def teardown_method(self, meth):
+        self.tearDown()
+
+    def setUp(self):
+        self.cache_folders = []
+
+    def tearDown(self):
+        for folder in self.cache_folders:
+            shutil.rmtree(folder)
+
+    def makeHistoryAndEntriesForRevids(self, revids, fill_cache_with=[]):
+        cache_folder = tempfile.mkdtemp()
+        self.cache_folders.append(cache_folder)
+        self.history = MockHistory()
+        self.cache = FileChangeCache(self.history, cache_folder)
+
+        self.entries = [MockEntry(revid) for revid in revids]
+
+        self.cache.get_file_changes([entry for entry in self.entries
+                                     if entry.revid in fill_cache_with])
+        self.history.fetched_revids.clear()
+
+    def test_empty_cache(self):
+        """An empty cache passes all the revids through to the history object.
+        """
+        revids = ['a', 'b']
+        self.makeHistoryAndEntriesForRevids(revids)
+
+        result = self.cache.get_file_changes(self.entries)
+
+        assert result == revids
+        assert self.history.fetched_revids == set(revids)
+
+    def test_full_cache(self):
+        """A full cache passes none of the revids through to the history
+        object.
+        """
+        revids = ['a', 'b']
+        self.makeHistoryAndEntriesForRevids(revids, fill_cache_with=revids)
+
+        result = self.cache.get_file_changes(self.entries)
+
+        assert result == revids
+        assert self.history.fetched_revids == set()
+
+    def test_partial_cache(self):
+        """A partially full cache passes some of the revids through to the
+        history object, and preserves the ordering of the argument list.
+        """
+        # To test the preservation of argument order code, we put the uncached
+        # revid at the beginning, middle and then end of the list of revids
+        # being asked for.
+        for i in range(3):
+            cached_revids = ['a', 'b']
+            revids = cached_revids[:]
+            revids.insert(i, 'uncached')
+            self.makeHistoryAndEntriesForRevids(
+                revids, fill_cache_with=cached_revids)
+
+            result = self.cache.get_file_changes(self.entries)
+            assert result == revids
+
+            assert self.history.fetched_revids == set(['uncached'])

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2009-06-08 23:02:49 +0000
+++ loggerhead/tests/test_simple.py	2009-02-18 10:40:22 +0000
@@ -1,26 +1,8 @@
-# Copyright (C) 2008, 2009 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
 import cgi
 import logging
 
 from bzrlib.tests import TestCaseWithTransport
 from bzrlib.util.configobj.configobj import ConfigObj
-from bzrlib import config
 
 from loggerhead.apps.branch import BranchWSGIApp
 from paste.fixture import TestApp
@@ -121,7 +103,6 @@
 
 
 class TestEmptyBranch(BasicTests):
-    """Test that an empty branch doesn't break"""
 
     def setUp(self):
         BasicTests.setUp(self)
@@ -137,37 +118,3 @@
         res = app.get('/files')
         res.mustcontain('No revisions!')
 
-
-class TestHiddenBranch(BasicTests):
-    """
-    Test that hidden branches aren't shown
-    FIXME: not tested that it doesn't show up on listings
-    """
-
-    def setUp(self):
-        BasicTests.setUp(self)
-        self.createBranch()
-        locations = config.locations_config_filename()
-        config.ensure_config_dir_exists()
-        open(locations, 'wb').write('[%s]\nhttp_serve = False'
-                                    % (self.tree.branch.base,))
-
-    def test_no_access(self):
-        app = self.setUpLoggerhead()
-        res = app.get('/changes', status=404)
-
-
-#class TestGlobalConfig(BasicTests):
-#    """
-#    Test that global config settings are respected
-#    """
-
-#    def setUp(self):
-#        BasicTests.setUp(self)
-#        self.createBranch()
-#        config.GlobalConfig().set_user_option('http_version', 'True')
-
-#    def test_setting_respected(self):
-        #FIXME: Figure out how to test this properly
-#        app = self.setUpLoggerhead()
-#        res = app.get('/changes', status=200)

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2009-10-17 06:35:33 +0000
+++ loggerhead/util.py	2009-03-01 20:57:52 +0000
@@ -19,6 +19,11 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+try:
+    from xml.etree import ElementTree as ET
+except ImportError:
+    from elementtree import ElementTree as ET
+
 import base64
 import cgi
 import datetime
@@ -31,13 +36,6 @@
 import os
 import subprocess
 
-try:
-    from xml.etree import ElementTree as ET
-except ImportError:
-    from elementtree import ElementTree as ET
-
-from simpletal.simpleTALUtils import HTMLStructureCleaner
-
 log = logging.getLogger("loggerhead.controllers")
 
 
@@ -129,7 +127,7 @@
     return _wrap_with_date_time_title(date, _displaydate(date))
 
 
-class Container(object):
+class Container (object):
     """
     Convert a dict into an object with attributes.
     """
@@ -181,14 +179,6 @@
         return '%s at %s' % (username, domains[-2])
     return '%s at %s' % (username, domains[0])
 
-def hide_emails(emails):
-    """
-    try to obscure any email address in a list of bazaar committers' names.
-    """
-    result = []
-    for email in emails:
-        result.append(hide_email(email))
-    return result
 
 # only do this if unicode turns out to be a problem
 #_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
@@ -217,6 +207,8 @@
 
     return: the same value recieved if not empty, and a '&nbsp;' if it is.
     """
+
+
     if s is None:
         return '&nbsp;'
     elif isinstance(s, int):
@@ -230,7 +222,6 @@
             s = s.decode('iso-8859-15')
         return s
 
-HSC = HTMLStructureCleaner()
 
 def fixed_width(s):
     """
@@ -247,10 +238,7 @@
             s = s.decode('utf-8')
         except UnicodeDecodeError:
             s = s.decode('iso-8859-15')
-
-    s = cgi.escape(s).expandtabs().replace(' ', NONBREAKING_SPACE)
-
-    return HSC.clean(s).replace('\n', '<br/>')
+    return s.expandtabs().replace(' ', NONBREAKING_SPACE)
 
 
 def fake_permissions(kind, executable):
@@ -314,7 +302,7 @@
 
     out = str(base)
     if (base < 100) and (dot != 0):
-        out += '.%d' % (dot,)
+        out += '.%d' % (dot)
     if divisor == KILO:
         out += 'K'
     elif divisor == MEG:
@@ -382,6 +370,8 @@
     """
     # Is our root directory itself a branch?
     if is_root:
+        if view == 'directory':
+            directory = 'files'
         breadcrumbs = [{
             'dir_name': path,
             'path': '',
@@ -445,6 +435,25 @@
     return new_decorator
 
 
+# common threading-lock decorator
+
+
+def with_lock(lockname, debug_name=None):
+    if debug_name is None:
+        debug_name = lockname
+
+    @decorator
+    def _decorator(unbound):
+
+        def locked(self, *args, **kw):
+            getattr(self, lockname).acquire()
+            try:
+                return unbound(self, *args, **kw)
+            finally:
+                getattr(self, lockname).release()
+        return locked
+    return _decorator
+
 
 @decorator
 def lsprof(f):
@@ -461,7 +470,7 @@
         now = time.time()
         msec = int(now * 1000) % 1000
         timestr = time.strftime('%Y%m%d%H%M%S',
-                                time.localtime(now)) + ('%03d' % (msec,))
+                                time.localtime(now)) + ('%03d' % msec)
         filename = f.__name__ + '-' + timestr + '.lsprof'
         cPickle.dump(stats, open(filename, 'w'), 2)
         return ret
@@ -533,7 +542,7 @@
     _reloader_environ_key = 'PYTHON_RELOADER_SHOULD_RUN'
 
     @classmethod
-    def _turn_sigterm_into_systemexit(cls):
+    def _turn_sigterm_into_systemexit(self):
         """
         Attempts to turn a SIGTERM exception into a SystemExit exception.
         """
@@ -547,26 +556,26 @@
         signal.signal(signal.SIGTERM, handle_term)
 
     @classmethod
-    def is_installed(cls):
-        return os.environ.get(cls._reloader_environ_key)
+    def is_installed(self):
+        return os.environ.get(self._reloader_environ_key)
 
     @classmethod
-    def install(cls):
+    def install(self):
         from paste import reloader
         reloader.install(int(1))
 
     @classmethod
-    def restart_with_reloader(cls):
+    def restart_with_reloader(self):
         """Based on restart_with_monitor from paste.script.serve."""
         print 'Starting subprocess with file monitor'
-        while True:
+        while 1:
             args = [sys.executable] + sys.argv
             new_environ = os.environ.copy()
-            new_environ[cls._reloader_environ_key] = 'true'
+            new_environ[self._reloader_environ_key] = 'true'
             proc = None
             try:
                 try:
-                    cls._turn_sigterm_into_systemexit()
+                    self._turn_sigterm_into_systemexit()
                     proc = subprocess.Popen(args, env=new_environ)
                     exit_code = proc.wait()
                     proc = None
@@ -575,7 +584,7 @@
                     return 1
             finally:
                 if (proc is not None
-                    and getattr(os, 'kill', None) is not None):
+                    and hasattr(os, 'kill')):
                     import signal
                     try:
                         os.kill(proc.pid, signal.SIGTERM)

=== modified file 'loggerhead/wholehistory.py'
--- loggerhead/wholehistory.py	2009-10-21 10:37:09 +0000
+++ loggerhead/wholehistory.py	2008-12-05 20:09:14 +0000
@@ -1,5 +1,4 @@
-#
-# Copyright (C) 2008, 2009 Canonical Ltd.
+# Cache the whole history data needed by loggerhead about a branch.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,7 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-"""Cache the whole history data needed by loggerhead about a branch."""
 
 import logging
 import time
@@ -32,54 +30,50 @@
     # Filter ghosts, and null:
     if NULL_REVISION in revision_graph:
         del revision_graph[NULL_REVISION]
-    for key, parents in revision_graph.iteritems():
+    for key, parents in revision_graph.items():
         revision_graph[key] = tuple(parent for parent in parents if parent
             in revision_graph)
     return revision_graph
 
 
 def compute_whole_history_data(branch):
-    """Compute _rev_info and _rev_indices for a branch.
-
-    See History.__doc__ for what these data structures mean.
-    """
     z = time.time()
 
     last_revid = branch.last_revision()
 
     log = logging.getLogger('loggerhead.%s' %
-                            (branch.get_config().get_nickname(),))
+                            branch.get_config().get_nickname())
 
     graph = branch.repository.get_graph()
-    parent_map = dict((key, value) for key, value in
-         graph.iter_ancestry([last_revid]) if value is not None)
+    parent_map = dict(((key, value) for key, value in
+         graph.iter_ancestry([last_revid]) if value is not None))
 
     _revision_graph = _strip_NULL_ghosts(parent_map)
-
-    _rev_info = []
-    _rev_indices = {}
-
+    _full_history = []
+    _revision_info = {}
+    _revno_revid = {}
     if is_null(last_revid):
         _merge_sort = []
     else:
         _merge_sort = merge_sort(
             _revision_graph, last_revid, generate_revno=True)
 
-    for info in _merge_sort:
-        seq, revid, merge_depth, revno, end_of_merge = info
+    for (seq, revid, merge_depth, revno, end_of_merge) in _merge_sort:
+        _full_history.append(revid)
         revno_str = '.'.join(str(n) for n in revno)
-        parents = _revision_graph[revid]
-        _rev_indices[revid] = len(_rev_info)
-        _rev_info.append([(seq, revid, merge_depth, revno_str, end_of_merge), (), parents])
-
-    for revid in _revision_graph.iterkeys():
-        if _rev_info[_rev_indices[revid]][0][2] == 0:
+        _revno_revid[revno_str] = revid
+        _revision_info[revid] = (
+            seq, revid, merge_depth, revno_str, end_of_merge)
+
+    _where_merged = {}
+
+    for revid in _revision_graph.keys():
+        if _revision_info[revid][2] == 0:
             continue
         for parent in _revision_graph[revid]:
-            c = _rev_info[_rev_indices[parent]]
-            if revid not in c[1]:
-                c[1] = c[1] + (revid,)
-
-    log.info('built revision graph cache: %r secs' % (time.time() - z,))
-
-    return (_rev_info, _rev_indices)
+            _where_merged.setdefault(parent, set()).add(revid)
+
+    log.info('built revision graph cache: %r secs' % (time.time() - z))
+
+    return (_revision_graph, _full_history, _revision_info,
+            _revno_revid, _merge_sort, _where_merged)

=== modified file 'loggerhead/zptsupport.py'
--- loggerhead/zptsupport.py	2009-03-02 05:44:20 +0000
+++ loggerhead/zptsupport.py	2008-10-24 02:26:05 +0000
@@ -18,7 +18,6 @@
 import logging
 import os
 import pkg_resources
-import re
 import StringIO
 
 from simpletal import simpleTAL, simpleTALES
@@ -34,11 +33,8 @@
     tinstance = _zpt_cache.get(tfile)
     stat = os.stat(tfile)
     if tinstance is None or tinstance.stat != stat:
-        text = open(tfile).read()
-        text = re.sub(r'\s*\n\s*', '\n', text)
-        text = re.sub(r'[ \t]+', ' ', text)
         tinstance = _zpt_cache[tfile] = TemplateWrapper(
-            simpleTAL.compileXMLTemplate(text), tfile, stat)
+            simpleTAL.compileXMLTemplate(open(tfile)), tfile, stat)
     return tinstance
 
 

=== removed file 'serve-branches'
--- serve-branches	2009-06-26 09:42:43 +0000
+++ serve-branches	1970-01-01 00:00:00 +0000
@@ -1,27 +0,0 @@
-#!/usr/bin/env python
-#
-# Copyright (C) 2008, 2009 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Search for branches underneath a directory and serve them all."""
-
-import sys
-
-from loggerhead.main import main
-
-
-if __name__ == "__main__":
-    main(sys.argv[1:])

=== renamed file 'loggerhead/main.py' => 'serve-branches' (properties changed: -x to +x)
--- loggerhead/main.py	2009-10-17 06:35:33 +0000
+++ serve-branches	2009-02-24 21:13:30 +0000
@@ -1,6 +1,4 @@
-#
-# Copyright (C) 2008, 2009 Canonical Ltd
-#
+#!/usr/bin/env python
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
@@ -21,6 +19,8 @@
 import os
 import sys
 
+from optparse import OptionParser
+
 from bzrlib.plugin import load_plugins
 
 from paste import httpserver
@@ -28,41 +28,87 @@
 from paste.translogger import TransLogger
 
 from loggerhead import __version__
-from loggerhead.apps.transport import (
-    BranchesFromTransportRoot, UserBranchesFromTransportRoot)
-from loggerhead.config import LoggerheadConfig
+from loggerhead.apps.filesystem import (
+    BranchesFromFileSystemRoot, UserBranchesFromFileSystemRoot)
 from loggerhead.util import Reloader
 from loggerhead.apps.error import ErrorHandlerApp
 
 
-def get_config_and_path(args):
-    config = LoggerheadConfig(args)
-
-    if config.get_option('show_version'):
-        print "loggerhead %s" % (__version__,)
+def command_line_parser():
+    parser = OptionParser("%prog [options] <path>")
+    parser.set_defaults(
+        user_dirs=False,
+        show_version=False,
+        log_folder=None,
+        )
+    parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
+                      help="Serve user directories as ~user.")
+    parser.add_option("--trunk-dir", metavar="DIR",
+                      help="The directory that contains the trunk branches.")
+    parser.add_option("--port", dest="user_port",
+                      help=("Port Loggerhead should listen on "
+                            "(defaults to 8080)."))
+    parser.add_option("--host", dest="user_host",
+                      help="Host Loggerhead should listen on.")
+    parser.add_option("--prefix", dest="user_prefix",
+                      help="Specify host prefix.")
+    parser.add_option("--profile", action="store_true", dest="profile",
+                      help="Generate callgrind profile data to "
+                        "%d-stats.callgrind on each request.")
+    parser.add_option("--reload", action="store_true", dest="reload",
+                      help="Restarts the application when changing python"
+                           " files. Only used for development purposes.")
+    parser.add_option('--log-folder', dest="log_folder",
+                      type=str, help="The directory to place log files in.")
+    parser.add_option("--version", action="store_true", dest="show_version",
+                      help="Print the software version and exit")
+    return parser
+
+
+def main(args):
+    parser = command_line_parser()
+    (options, args) = parser.parse_args(sys.argv[1:])
+
+    if options.show_version:
+        print "loggerhead %s" % __version__
         sys.exit(0)
 
-    if config.arg_count > 1:
-        config.print_help()
-        sys.exit(1)
-    elif config.arg_count == 1:
-        base = config.get_arg(0)
-    else:
-        base = '.'
-
-    if not config.get_option('allow_writes'):
-        base = 'readonly+' + base
-
-    return config, base
-
-
-def setup_logging(config):
+    if len(args) > 1:
+        parser.print_help()
+        sys.exit(1)
+    elif len(args) == 1:
+        [path] = args
+    else:
+        path = '.'
+
+    if not os.path.isdir(path):
+        print "%s is not a directory" % path
+        sys.exit(1)
+
+    if options.trunk_dir and not options.user_dirs:
+        print "--trunk-dir is only valid with --user-dirs"
+        sys.exit(1)
+
+    if options.reload:
+        if Reloader.is_installed():
+            Reloader.install()
+        else:
+            return Reloader.restart_with_reloader()
+
+    if options.user_dirs:
+        if not options.trunk_dir:
+            print "You didn't specify a directory for the trunk directories."
+            sys.exit(1)
+        app = UserBranchesFromFileSystemRoot(path, options.trunk_dir)
+    else:
+        app = BranchesFromFileSystemRoot(path)
+
+    # setup_logging()
     logging.basicConfig()
     logging.getLogger('').setLevel(logging.DEBUG)
-    logger = logging.getLogger('loggerhead')
-    if config.get_option('log_folder'):
-        logfile_path = os.path.join(
-            config.get_option('log_folder'), 'serve-branches.log')
+    logger = getattr(app, 'log', logging.getLogger('loggerhead'))
+    if options.log_folder:
+        logfile_path = os.path.join(options.log_folder, 'serve-branches.log')
     else:
         logfile_path = 'serve-branches.log'
     logfile = logging.FileHandler(logfile_path, 'a')
@@ -71,41 +117,16 @@
     logfile.setFormatter(formatter)
     logfile.setLevel(logging.DEBUG)
     logger.addHandler(logfile)
-    return logger
-
-
-def make_app_for_config_and_path(config, base):
-    if config.get_option('trunk_dir') and not config.get_option('user_dirs'):
-        print "--trunk-dir is only valid with --user-dirs"
-        sys.exit(1)
-
-    if config.get_option('reload'):
-        if Reloader.is_installed():
-            Reloader.install()
-        else:
-            return Reloader.restart_with_reloader()
-
-    if config.get_option('user_dirs'):
-        if not config.get_option('trunk_dir'):
-            print "You didn't specify a directory for the trunk directories."
-            sys.exit(1)
-        app = UserBranchesFromTransportRoot(base, config)
-    else:
-        app = BranchesFromTransportRoot(base, config)
-
-    setup_logging(config)
-
-    if config.get_option('profile'):
+    # setup_logging() #end
+    app = TransLogger(app, logger=logger)
+    if options.profile:
         from loggerhead.middleware.profile import LSProfMiddleware
         app = LSProfMiddleware(app)
-    if config.get_option('memory_profile'):
-        from dozer import Dozer
-        app = Dozer(app)
 
-    if not config.get_option('user_prefix'):
+    if not options.user_prefix:
         prefix = '/'
     else:
-        prefix = config.get_option('user_prefix')
+        prefix = options.user_prefix
         if not prefix.startswith('/'):
             prefix = '/' + prefix
 
@@ -129,26 +150,21 @@
 
     app = HTTPExceptionHandler(app)
     app = ErrorHandlerApp(app)
-    app = TransLogger(app, logger=logging.getLogger('loggerhead'))
-
-    return app
-
-
-def main(args):
-    load_plugins()
-
-    config, path = get_config_and_path(args)
-
-    app = make_app_for_config_and_path(config, path)
-
-    if not config.get_option('user_port'):
+
+    if not options.user_port:
         port = '8080'
     else:
-        port = config.get_option('user_port')
+        port = options.user_port
 
-    if not config.get_option('user_host'):
+    if not options.user_host:
         host = '0.0.0.0'
     else:
-        host = config.get_option('user_host')
+        host = options.user_host
+
+    load_plugins()
 
     httpserver.serve(app, host=host, port=port)
+
+
+if __name__ == "__main__":
+    main(sys.argv)

=== modified file 'setup.py' (properties changed: +x to -x)
--- setup.py	2009-10-17 06:19:40 +0000
+++ setup.py	2008-11-20 16:55:47 +0000
@@ -18,8 +18,8 @@
 
 """Loggerhead is a web viewer for projects in bazaar"""
 
+
 from distutils.core import setup
-
 import loggerhead
 
 
@@ -34,9 +34,7 @@
     packages = ["loggerhead",
                 "loggerhead/apps",
                 "loggerhead/controllers",
-                "loggerhead/templates",
-                "bzrlib.plugins.loggerhead"],
-    package_dir={'bzrlib.plugins.loggerhead':'.'},
+                "loggerhead/templates"],
     package_data = {"loggerhead": ["templates/*.pt",
                                    "static/css/*.css",
                                    "static/javascript/*.js",

=== modified file 'start-loggerhead'
--- start-loggerhead	2009-10-17 06:35:33 +0000
+++ start-loggerhead	2009-02-19 01:24:20 +0000
@@ -13,13 +13,11 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""
-WARNING! This script has been deprecated and will go away soon!
-A script for starting the loggerhead process.
-"""
+"""A script for starting the loggerhead process."""
 
 
 import logging
+import logging.handlers
 from optparse import OptionParser
 import os
 import sys
@@ -34,18 +32,11 @@
 
 from loggerhead import daemon
 from loggerhead.apps.config import Root
-from loggerhead.trace import setup_logging
+from loggerhead.trace import make_handler, setup_logging
 from loggerhead.apps.error import ErrorHandlerApp
 
 
 def main():
-    sys.stderr.write('\n\n')
-    sys.stderr.write('WARNING!!! This script has been deprecated by '
-                     'serve-branches, and will be removed in the next '
-                     'release. Please migrate to serve-branches and report '
-                     'any missing features.\n')
-    sys.stderr.write('\n\n')
-
     home = os.path.realpath(os.path.dirname(__file__))
     default_pidfile = os.path.join(home, 'loggerhead.pid')
     default_configfile = os.path.join(home, 'loggerhead.conf')
@@ -102,7 +93,7 @@
     if not options.foreground:
         sys.stderr.write('\n')
         sys.stderr.write('Launching loggerhead into the background.\n')
-        sys.stderr.write('PID file: %s\n' % (options.pidfile,))
+        sys.stderr.write('PID file: %s\n' % options.pidfile)
         sys.stderr.write('\n')
 
         daemon.daemonize(options.pidfile, home)

=== modified file 'stop-loggerhead'
--- stop-loggerhead	2009-05-13 14:03:48 +0000
+++ stop-loggerhead	2008-10-24 02:26:05 +0000
@@ -32,7 +32,7 @@
 try:
     f = open(options.pidfile, 'r')
 except IOError, e:
-    print 'Pid file %s not found.' % (options.pidfile,)
+    print 'Pid file %s not found.' % options.pidfile
     sys.exit(1)
 
 pid = int(f.readline())
@@ -44,7 +44,7 @@
     sys.exit(1)
 
 print
-print 'Shutting down previous server @ pid %d.' % (pid,)
+print 'Shutting down previous server @ pid %d.' % pid
 print
 
 import signal

